-- $Source: /home/dsd/d/aa/monoBANK/AA/j_ada.calendar.tgt.bdy,v $ 
-- $Revision: 1.2 $ $Date: 96/08/15 15:10:20 $ $Author: jparadis $ 
with java.util.Date; use java.util.Date;

package body Ada.Calendar.TGT is

   -- This target dependent package provides the routines
   -- to support package Ada.Calendar.

   package java renames Standard.Java;
   -- "java" is hidden by enumeral in package System called "java".

   pragma suppress( elaboration_check );
      
   function GMT_Clock return time is
      d : Date_Ptr;
      t : time;
      Year : Year_Number;
      Month : Month_Number;
      Day : Day_Number;
      Day_Length : Day_Duration;
   begin
      d := new_Date;
      Year := GetYear(D) + 1900;
      Month := GetMonth(D) + 1;
      Day := GetDate(D);
      Day_Length := Duration(GetHours(D) * 3600 + 
			     GetMinutes(D) * 60 + GetSeconds(D));
      return Time_Of(Year, Month, Day, Day_Length);
   end GMT_Clock;

   -- Returns GMT time in Calendar.Time format;
   -- The GMT_Clock value is returned unchanged by Calendar.Clock.
   -- If the GMT_Clock needs initialization, it could be done
   -- by the package body elaboration.
      

   function Local_Time_Zone return duration is	
      d : Date_Ptr;
   begin
      d := new_Date;
      return Duration(getTimezoneOffset(d) *  60);
   end Local_Time_Zone;

   -- Returns number of seconds difference between local time and GMT.
   -- This value is subtracted from GMT to convert to local,
   -- and is added to local to convert to GMT, so it should be
   -- positive for time zones west of GMT up to the international
   -- date line (true of all time zones in the USA).
   -- This value is a function so that it may be changed while a
   -- program is executing.
   -- Because Calendar.Time is always GMT, changing the time zone
   -- should not affect Calendar.Clock nor active timers based
   -- on Ada.Calendar.Time.
   -- How a user program changes the local time zone, or even whether
   -- such a change is supported, is not specified by either the LRM
   -- or this interface.

end Ada.Calendar.Tgt; 

