-- $Source: /home/dsd/d/aa/monoBANK/AA/ada.characters.handling.bdy,v $
-- $Revision: 1.2 $ $Date: 95/10/10 13:46:09 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

-- ARM(5;0) C.3.2

package body Ada.Characters.Handling is

    pragma Suppress( Elaboration_Check );

--Character classification items
 
    type Char_Classification_Element is record
        Is_Control_Char           : Boolean;
        Is_Graphic_Char           : Boolean;
        Is_Letter_Char            : Boolean;
        Is_Lower_Char             : Boolean;
        Is_Upper_Char             : Boolean;
        Is_Basic_Char             : Boolean;
        Is_Digit_Char             : Boolean;
        Is_Hexadecimal_Digit_Char : Boolean;
        Is_Alphanumeric_Char      : Boolean;
        Is_Special_Char           : Boolean;
    end record;
    pragma Pack( Char_Classification_Element );

    type Char_Classification_Array is array( Character ) of
      Char_Classification_Element;

    Ctype : constant Char_Classification_Array :=
      (
        Character'val(   0 ) .. Character'val(  31 ) =>
          ( Is_Control_Char           => TRUE,
            Is_Graphic_Char           => FALSE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => FALSE ),
        Character'val(  32 ) .. Character'val(  47 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => TRUE ),
        Character'val(  48 ) .. Character'val(  57 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => TRUE,
            Is_Hexadecimal_Digit_Char => TRUE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val(  58 ) .. Character'val(  64 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => TRUE ),
        Character'val(  65 ) .. Character'val(  70 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => TRUE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val(  71 ) .. Character'val(  90 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val(  91 ) .. Character'val(  96 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => TRUE ),
        Character'val(  97 ) .. Character'val( 102 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => TRUE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 103 ) .. Character'val( 122 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 123 ) .. Character'val( 126 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => TRUE ),
        Character'val( 127 ) .. Character'val( 127 ) =>
          ( Is_Control_Char           => TRUE,
            Is_Graphic_Char           => FALSE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => FALSE ),
        Character'val( 128 ) .. Character'val( 159 ) =>
          ( Is_Control_Char           => TRUE,
            Is_Graphic_Char           => FALSE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => FALSE ),
        Character'val( 160 ) .. Character'val( 191 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => TRUE ),
        Character'val( 192 ) .. Character'val( 197 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 198 ) .. Character'val( 198 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 199 ) .. Character'val( 207 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 208 ) .. Character'val( 208 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 209 ) .. Character'val( 214 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 215 ) .. Character'val( 215 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => TRUE ),
        Character'val( 216 ) .. Character'val( 221 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 222 ) .. Character'val( 222 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => TRUE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 223 ) .. Character'val( 223 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 224 ) .. Character'val( 229 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 230 ) .. Character'val( 230 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 231 ) .. Character'val( 239 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 240 ) .. Character'val( 240 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 241 ) .. Character'val( 246 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 247 ) .. Character'val( 247 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => FALSE,
            Is_Lower_Char             => FALSE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => FALSE,
            Is_Special_Char           => TRUE ),
        Character'val( 248 ) .. Character'val( 253 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 254 ) .. Character'val( 254 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => TRUE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE ),
        Character'val( 255 ) .. Character'val( 255 ) =>
          ( Is_Control_Char           => FALSE,
            Is_Graphic_Char           => TRUE,
            Is_Letter_Char            => TRUE,
            Is_Lower_Char             => TRUE,
            Is_Upper_Char             => FALSE,
            Is_Basic_Char             => FALSE,
            Is_Digit_Char             => FALSE,
            Is_Hexadecimal_Digit_Char => FALSE,
            Is_Alphanumeric_Char      => TRUE,
            Is_Special_Char           => FALSE )
      );

--Conversion items for Character and String

    type Small_Character is new Character;
    for Small_Character'size use 8;

    type Char_Mapping_Element is record
	Mapped_To_Upper : Small_Character;
	Mapped_To_Lower : Small_Character;
	Mapped_To_Basic : Small_Character;
    end record;
    pragma Pack( Char_Mapping_Element );

    type Char_Mapping_Array is array( Character ) of
      Char_Mapping_Element;

    Cmap : constant Char_Mapping_Array :=
      (
        Character'val(   0 ) =>
          ( Mapped_To_Upper => Small_Character'val(   0 ),
            Mapped_To_Lower => Small_Character'val(   0 ),
            Mapped_To_Basic => Small_Character'val(   0 ) ),
        Character'val(   1 ) =>
          ( Mapped_To_Upper => Small_Character'val(   1 ),
            Mapped_To_Lower => Small_Character'val(   1 ),
            Mapped_To_Basic => Small_Character'val(   1 ) ),
        Character'val(   2 ) =>
          ( Mapped_To_Upper => Small_Character'val(   2 ),
            Mapped_To_Lower => Small_Character'val(   2 ),
            Mapped_To_Basic => Small_Character'val(   2 ) ),
        Character'val(   3 ) =>
          ( Mapped_To_Upper => Small_Character'val(   3 ),
            Mapped_To_Lower => Small_Character'val(   3 ),
            Mapped_To_Basic => Small_Character'val(   3 ) ),
        Character'val(   4 ) =>
          ( Mapped_To_Upper => Small_Character'val(   4 ),
            Mapped_To_Lower => Small_Character'val(   4 ),
            Mapped_To_Basic => Small_Character'val(   4 ) ),
        Character'val(   5 ) =>
          ( Mapped_To_Upper => Small_Character'val(   5 ),
            Mapped_To_Lower => Small_Character'val(   5 ),
            Mapped_To_Basic => Small_Character'val(   5 ) ),
        Character'val(   6 ) =>
          ( Mapped_To_Upper => Small_Character'val(   6 ),
            Mapped_To_Lower => Small_Character'val(   6 ),
            Mapped_To_Basic => Small_Character'val(   6 ) ),
        Character'val(   7 ) =>
          ( Mapped_To_Upper => Small_Character'val(   7 ),
            Mapped_To_Lower => Small_Character'val(   7 ),
            Mapped_To_Basic => Small_Character'val(   7 ) ),
        Character'val(   8 ) =>
          ( Mapped_To_Upper => Small_Character'val(   8 ),
            Mapped_To_Lower => Small_Character'val(   8 ),
            Mapped_To_Basic => Small_Character'val(   8 ) ),
        Character'val(   9 ) =>
          ( Mapped_To_Upper => Small_Character'val(   9 ),
            Mapped_To_Lower => Small_Character'val(   9 ),
            Mapped_To_Basic => Small_Character'val(   9 ) ),
        Character'val(  10 ) =>
          ( Mapped_To_Upper => Small_Character'val(  10 ),
            Mapped_To_Lower => Small_Character'val(  10 ),
            Mapped_To_Basic => Small_Character'val(  10 ) ),
        Character'val(  11 ) =>
          ( Mapped_To_Upper => Small_Character'val(  11 ),
            Mapped_To_Lower => Small_Character'val(  11 ),
            Mapped_To_Basic => Small_Character'val(  11 ) ),
        Character'val(  12 ) =>
          ( Mapped_To_Upper => Small_Character'val(  12 ),
            Mapped_To_Lower => Small_Character'val(  12 ),
            Mapped_To_Basic => Small_Character'val(  12 ) ),
        Character'val(  13 ) =>
          ( Mapped_To_Upper => Small_Character'val(  13 ),
            Mapped_To_Lower => Small_Character'val(  13 ),
            Mapped_To_Basic => Small_Character'val(  13 ) ),
        Character'val(  14 ) =>
          ( Mapped_To_Upper => Small_Character'val(  14 ),
            Mapped_To_Lower => Small_Character'val(  14 ),
            Mapped_To_Basic => Small_Character'val(  14 ) ),
        Character'val(  15 ) =>
          ( Mapped_To_Upper => Small_Character'val(  15 ),
            Mapped_To_Lower => Small_Character'val(  15 ),
            Mapped_To_Basic => Small_Character'val(  15 ) ),
        Character'val(  16 ) =>
          ( Mapped_To_Upper => Small_Character'val(  16 ),
            Mapped_To_Lower => Small_Character'val(  16 ),
            Mapped_To_Basic => Small_Character'val(  16 ) ),
        Character'val(  17 ) =>
          ( Mapped_To_Upper => Small_Character'val(  17 ),
            Mapped_To_Lower => Small_Character'val(  17 ),
            Mapped_To_Basic => Small_Character'val(  17 ) ),
        Character'val(  18 ) =>
          ( Mapped_To_Upper => Small_Character'val(  18 ),
            Mapped_To_Lower => Small_Character'val(  18 ),
            Mapped_To_Basic => Small_Character'val(  18 ) ),
        Character'val(  19 ) =>
          ( Mapped_To_Upper => Small_Character'val(  19 ),
            Mapped_To_Lower => Small_Character'val(  19 ),
            Mapped_To_Basic => Small_Character'val(  19 ) ),
        Character'val(  20 ) =>
          ( Mapped_To_Upper => Small_Character'val(  20 ),
            Mapped_To_Lower => Small_Character'val(  20 ),
            Mapped_To_Basic => Small_Character'val(  20 ) ),
        Character'val(  21 ) =>
          ( Mapped_To_Upper => Small_Character'val(  21 ),
            Mapped_To_Lower => Small_Character'val(  21 ),
            Mapped_To_Basic => Small_Character'val(  21 ) ),
        Character'val(  22 ) =>
          ( Mapped_To_Upper => Small_Character'val(  22 ),
            Mapped_To_Lower => Small_Character'val(  22 ),
            Mapped_To_Basic => Small_Character'val(  22 ) ),
        Character'val(  23 ) =>
          ( Mapped_To_Upper => Small_Character'val(  23 ),
            Mapped_To_Lower => Small_Character'val(  23 ),
            Mapped_To_Basic => Small_Character'val(  23 ) ),
        Character'val(  24 ) =>
          ( Mapped_To_Upper => Small_Character'val(  24 ),
            Mapped_To_Lower => Small_Character'val(  24 ),
            Mapped_To_Basic => Small_Character'val(  24 ) ),
        Character'val(  25 ) =>
          ( Mapped_To_Upper => Small_Character'val(  25 ),
            Mapped_To_Lower => Small_Character'val(  25 ),
            Mapped_To_Basic => Small_Character'val(  25 ) ),
        Character'val(  26 ) =>
          ( Mapped_To_Upper => Small_Character'val(  26 ),
            Mapped_To_Lower => Small_Character'val(  26 ),
            Mapped_To_Basic => Small_Character'val(  26 ) ),
        Character'val(  27 ) =>
          ( Mapped_To_Upper => Small_Character'val(  27 ),
            Mapped_To_Lower => Small_Character'val(  27 ),
            Mapped_To_Basic => Small_Character'val(  27 ) ),
        Character'val(  28 ) =>
          ( Mapped_To_Upper => Small_Character'val(  28 ),
            Mapped_To_Lower => Small_Character'val(  28 ),
            Mapped_To_Basic => Small_Character'val(  28 ) ),
        Character'val(  29 ) =>
          ( Mapped_To_Upper => Small_Character'val(  29 ),
            Mapped_To_Lower => Small_Character'val(  29 ),
            Mapped_To_Basic => Small_Character'val(  29 ) ),
        Character'val(  30 ) =>
          ( Mapped_To_Upper => Small_Character'val(  30 ),
            Mapped_To_Lower => Small_Character'val(  30 ),
            Mapped_To_Basic => Small_Character'val(  30 ) ),
        Character'val(  31 ) =>
          ( Mapped_To_Upper => Small_Character'val(  31 ),
            Mapped_To_Lower => Small_Character'val(  31 ),
            Mapped_To_Basic => Small_Character'val(  31 ) ),
        Character'val(  32 ) =>
          ( Mapped_To_Upper => Small_Character'val(  32 ),
            Mapped_To_Lower => Small_Character'val(  32 ),
            Mapped_To_Basic => Small_Character'val(  32 ) ),
        Character'val(  33 ) =>
          ( Mapped_To_Upper => Small_Character'val(  33 ),
            Mapped_To_Lower => Small_Character'val(  33 ),
            Mapped_To_Basic => Small_Character'val(  33 ) ),
        Character'val(  34 ) =>
          ( Mapped_To_Upper => Small_Character'val(  34 ),
            Mapped_To_Lower => Small_Character'val(  34 ),
            Mapped_To_Basic => Small_Character'val(  34 ) ),
        Character'val(  35 ) =>
          ( Mapped_To_Upper => Small_Character'val(  35 ),
            Mapped_To_Lower => Small_Character'val(  35 ),
            Mapped_To_Basic => Small_Character'val(  35 ) ),
        Character'val(  36 ) =>
          ( Mapped_To_Upper => Small_Character'val(  36 ),
            Mapped_To_Lower => Small_Character'val(  36 ),
            Mapped_To_Basic => Small_Character'val(  36 ) ),
        Character'val(  37 ) =>
          ( Mapped_To_Upper => Small_Character'val(  37 ),
            Mapped_To_Lower => Small_Character'val(  37 ),
            Mapped_To_Basic => Small_Character'val(  37 ) ),
        Character'val(  38 ) =>
          ( Mapped_To_Upper => Small_Character'val(  38 ),
            Mapped_To_Lower => Small_Character'val(  38 ),
            Mapped_To_Basic => Small_Character'val(  38 ) ),
        Character'val(  39 ) =>
          ( Mapped_To_Upper => Small_Character'val(  39 ),
            Mapped_To_Lower => Small_Character'val(  39 ),
            Mapped_To_Basic => Small_Character'val(  39 ) ),
        Character'val(  40 ) =>
          ( Mapped_To_Upper => Small_Character'val(  40 ),
            Mapped_To_Lower => Small_Character'val(  40 ),
            Mapped_To_Basic => Small_Character'val(  40 ) ),
        Character'val(  41 ) =>
          ( Mapped_To_Upper => Small_Character'val(  41 ),
            Mapped_To_Lower => Small_Character'val(  41 ),
            Mapped_To_Basic => Small_Character'val(  41 ) ),
        Character'val(  42 ) =>
          ( Mapped_To_Upper => Small_Character'val(  42 ),
            Mapped_To_Lower => Small_Character'val(  42 ),
            Mapped_To_Basic => Small_Character'val(  42 ) ),
        Character'val(  43 ) =>
          ( Mapped_To_Upper => Small_Character'val(  43 ),
            Mapped_To_Lower => Small_Character'val(  43 ),
            Mapped_To_Basic => Small_Character'val(  43 ) ),
        Character'val(  44 ) =>
          ( Mapped_To_Upper => Small_Character'val(  44 ),
            Mapped_To_Lower => Small_Character'val(  44 ),
            Mapped_To_Basic => Small_Character'val(  44 ) ),
        Character'val(  45 ) =>
          ( Mapped_To_Upper => Small_Character'val(  45 ),
            Mapped_To_Lower => Small_Character'val(  45 ),
            Mapped_To_Basic => Small_Character'val(  45 ) ),
        Character'val(  46 ) =>
          ( Mapped_To_Upper => Small_Character'val(  46 ),
            Mapped_To_Lower => Small_Character'val(  46 ),
            Mapped_To_Basic => Small_Character'val(  46 ) ),
        Character'val(  47 ) =>
          ( Mapped_To_Upper => Small_Character'val(  47 ),
            Mapped_To_Lower => Small_Character'val(  47 ),
            Mapped_To_Basic => Small_Character'val(  47 ) ),
        Character'val(  48 ) =>
          ( Mapped_To_Upper => Small_Character'val(  48 ),
            Mapped_To_Lower => Small_Character'val(  48 ),
            Mapped_To_Basic => Small_Character'val(  48 ) ),
        Character'val(  49 ) =>
          ( Mapped_To_Upper => Small_Character'val(  49 ),
            Mapped_To_Lower => Small_Character'val(  49 ),
            Mapped_To_Basic => Small_Character'val(  49 ) ),
        Character'val(  50 ) =>
          ( Mapped_To_Upper => Small_Character'val(  50 ),
            Mapped_To_Lower => Small_Character'val(  50 ),
            Mapped_To_Basic => Small_Character'val(  50 ) ),
        Character'val(  51 ) =>
          ( Mapped_To_Upper => Small_Character'val(  51 ),
            Mapped_To_Lower => Small_Character'val(  51 ),
            Mapped_To_Basic => Small_Character'val(  51 ) ),
        Character'val(  52 ) =>
          ( Mapped_To_Upper => Small_Character'val(  52 ),
            Mapped_To_Lower => Small_Character'val(  52 ),
            Mapped_To_Basic => Small_Character'val(  52 ) ),
        Character'val(  53 ) =>
          ( Mapped_To_Upper => Small_Character'val(  53 ),
            Mapped_To_Lower => Small_Character'val(  53 ),
            Mapped_To_Basic => Small_Character'val(  53 ) ),
        Character'val(  54 ) =>
          ( Mapped_To_Upper => Small_Character'val(  54 ),
            Mapped_To_Lower => Small_Character'val(  54 ),
            Mapped_To_Basic => Small_Character'val(  54 ) ),
        Character'val(  55 ) =>
          ( Mapped_To_Upper => Small_Character'val(  55 ),
            Mapped_To_Lower => Small_Character'val(  55 ),
            Mapped_To_Basic => Small_Character'val(  55 ) ),
        Character'val(  56 ) =>
          ( Mapped_To_Upper => Small_Character'val(  56 ),
            Mapped_To_Lower => Small_Character'val(  56 ),
            Mapped_To_Basic => Small_Character'val(  56 ) ),
        Character'val(  57 ) =>
          ( Mapped_To_Upper => Small_Character'val(  57 ),
            Mapped_To_Lower => Small_Character'val(  57 ),
            Mapped_To_Basic => Small_Character'val(  57 ) ),
        Character'val(  58 ) =>
          ( Mapped_To_Upper => Small_Character'val(  58 ),
            Mapped_To_Lower => Small_Character'val(  58 ),
            Mapped_To_Basic => Small_Character'val(  58 ) ),
        Character'val(  59 ) =>
          ( Mapped_To_Upper => Small_Character'val(  59 ),
            Mapped_To_Lower => Small_Character'val(  59 ),
            Mapped_To_Basic => Small_Character'val(  59 ) ),
        Character'val(  60 ) =>
          ( Mapped_To_Upper => Small_Character'val(  60 ),
            Mapped_To_Lower => Small_Character'val(  60 ),
            Mapped_To_Basic => Small_Character'val(  60 ) ),
        Character'val(  61 ) =>
          ( Mapped_To_Upper => Small_Character'val(  61 ),
            Mapped_To_Lower => Small_Character'val(  61 ),
            Mapped_To_Basic => Small_Character'val(  61 ) ),
        Character'val(  62 ) =>
          ( Mapped_To_Upper => Small_Character'val(  62 ),
            Mapped_To_Lower => Small_Character'val(  62 ),
            Mapped_To_Basic => Small_Character'val(  62 ) ),
        Character'val(  63 ) =>
          ( Mapped_To_Upper => Small_Character'val(  63 ),
            Mapped_To_Lower => Small_Character'val(  63 ),
            Mapped_To_Basic => Small_Character'val(  63 ) ),
        Character'val(  64 ) =>
          ( Mapped_To_Upper => Small_Character'val(  64 ),
            Mapped_To_Lower => Small_Character'val(  64 ),
            Mapped_To_Basic => Small_Character'val(  64 ) ),
        Character'val(  65 ) =>
          ( Mapped_To_Upper => Small_Character'val(  65 ),
            Mapped_To_Lower => Small_Character'val(  97 ),
            Mapped_To_Basic => Small_Character'val(  65 ) ),
        Character'val(  66 ) =>
          ( Mapped_To_Upper => Small_Character'val(  66 ),
            Mapped_To_Lower => Small_Character'val(  98 ),
            Mapped_To_Basic => Small_Character'val(  66 ) ),
        Character'val(  67 ) =>
          ( Mapped_To_Upper => Small_Character'val(  67 ),
            Mapped_To_Lower => Small_Character'val(  99 ),
            Mapped_To_Basic => Small_Character'val(  67 ) ),
        Character'val(  68 ) =>
          ( Mapped_To_Upper => Small_Character'val(  68 ),
            Mapped_To_Lower => Small_Character'val( 100 ),
            Mapped_To_Basic => Small_Character'val(  68 ) ),
        Character'val(  69 ) =>
          ( Mapped_To_Upper => Small_Character'val(  69 ),
            Mapped_To_Lower => Small_Character'val( 101 ),
            Mapped_To_Basic => Small_Character'val(  69 ) ),
        Character'val(  70 ) =>
          ( Mapped_To_Upper => Small_Character'val(  70 ),
            Mapped_To_Lower => Small_Character'val( 102 ),
            Mapped_To_Basic => Small_Character'val(  70 ) ),
        Character'val(  71 ) =>
          ( Mapped_To_Upper => Small_Character'val(  71 ),
            Mapped_To_Lower => Small_Character'val( 103 ),
            Mapped_To_Basic => Small_Character'val(  71 ) ),
        Character'val(  72 ) =>
          ( Mapped_To_Upper => Small_Character'val(  72 ),
            Mapped_To_Lower => Small_Character'val( 104 ),
            Mapped_To_Basic => Small_Character'val(  72 ) ),
        Character'val(  73 ) =>
          ( Mapped_To_Upper => Small_Character'val(  73 ),
            Mapped_To_Lower => Small_Character'val( 105 ),
            Mapped_To_Basic => Small_Character'val(  73 ) ),
        Character'val(  74 ) =>
          ( Mapped_To_Upper => Small_Character'val(  74 ),
            Mapped_To_Lower => Small_Character'val( 106 ),
            Mapped_To_Basic => Small_Character'val(  74 ) ),
        Character'val(  75 ) =>
          ( Mapped_To_Upper => Small_Character'val(  75 ),
            Mapped_To_Lower => Small_Character'val( 107 ),
            Mapped_To_Basic => Small_Character'val(  75 ) ),
        Character'val(  76 ) =>
          ( Mapped_To_Upper => Small_Character'val(  76 ),
            Mapped_To_Lower => Small_Character'val( 108 ),
            Mapped_To_Basic => Small_Character'val(  76 ) ),
        Character'val(  77 ) =>
          ( Mapped_To_Upper => Small_Character'val(  77 ),
            Mapped_To_Lower => Small_Character'val( 109 ),
            Mapped_To_Basic => Small_Character'val(  77 ) ),
        Character'val(  78 ) =>
          ( Mapped_To_Upper => Small_Character'val(  78 ),
            Mapped_To_Lower => Small_Character'val( 110 ),
            Mapped_To_Basic => Small_Character'val(  78 ) ),
        Character'val(  79 ) =>
          ( Mapped_To_Upper => Small_Character'val(  79 ),
            Mapped_To_Lower => Small_Character'val( 111 ),
            Mapped_To_Basic => Small_Character'val(  79 ) ),
        Character'val(  80 ) =>
          ( Mapped_To_Upper => Small_Character'val(  80 ),
            Mapped_To_Lower => Small_Character'val( 112 ),
            Mapped_To_Basic => Small_Character'val(  80 ) ),
        Character'val(  81 ) =>
          ( Mapped_To_Upper => Small_Character'val(  81 ),
            Mapped_To_Lower => Small_Character'val( 113 ),
            Mapped_To_Basic => Small_Character'val(  81 ) ),
        Character'val(  82 ) =>
          ( Mapped_To_Upper => Small_Character'val(  82 ),
            Mapped_To_Lower => Small_Character'val( 114 ),
            Mapped_To_Basic => Small_Character'val(  82 ) ),
        Character'val(  83 ) =>
          ( Mapped_To_Upper => Small_Character'val(  83 ),
            Mapped_To_Lower => Small_Character'val( 115 ),
            Mapped_To_Basic => Small_Character'val(  83 ) ),
        Character'val(  84 ) =>
          ( Mapped_To_Upper => Small_Character'val(  84 ),
            Mapped_To_Lower => Small_Character'val( 116 ),
            Mapped_To_Basic => Small_Character'val(  84 ) ),
        Character'val(  85 ) =>
          ( Mapped_To_Upper => Small_Character'val(  85 ),
            Mapped_To_Lower => Small_Character'val( 117 ),
            Mapped_To_Basic => Small_Character'val(  85 ) ),
        Character'val(  86 ) =>
          ( Mapped_To_Upper => Small_Character'val(  86 ),
            Mapped_To_Lower => Small_Character'val( 118 ),
            Mapped_To_Basic => Small_Character'val(  86 ) ),
        Character'val(  87 ) =>
          ( Mapped_To_Upper => Small_Character'val(  87 ),
            Mapped_To_Lower => Small_Character'val( 119 ),
            Mapped_To_Basic => Small_Character'val(  87 ) ),
        Character'val(  88 ) =>
          ( Mapped_To_Upper => Small_Character'val(  88 ),
            Mapped_To_Lower => Small_Character'val( 120 ),
            Mapped_To_Basic => Small_Character'val(  88 ) ),
        Character'val(  89 ) =>
          ( Mapped_To_Upper => Small_Character'val(  89 ),
            Mapped_To_Lower => Small_Character'val( 121 ),
            Mapped_To_Basic => Small_Character'val(  89 ) ),
        Character'val(  90 ) =>
          ( Mapped_To_Upper => Small_Character'val(  90 ),
            Mapped_To_Lower => Small_Character'val( 122 ),
            Mapped_To_Basic => Small_Character'val(  90 ) ),
        Character'val(  91 ) =>
          ( Mapped_To_Upper => Small_Character'val(  91 ),
            Mapped_To_Lower => Small_Character'val(  91 ),
            Mapped_To_Basic => Small_Character'val(  91 ) ),
        Character'val(  92 ) =>
          ( Mapped_To_Upper => Small_Character'val(  92 ),
            Mapped_To_Lower => Small_Character'val(  92 ),
            Mapped_To_Basic => Small_Character'val(  92 ) ),
        Character'val(  93 ) =>
          ( Mapped_To_Upper => Small_Character'val(  93 ),
            Mapped_To_Lower => Small_Character'val(  93 ),
            Mapped_To_Basic => Small_Character'val(  93 ) ),
        Character'val(  94 ) =>
          ( Mapped_To_Upper => Small_Character'val(  94 ),
            Mapped_To_Lower => Small_Character'val(  94 ),
            Mapped_To_Basic => Small_Character'val(  94 ) ),
        Character'val(  95 ) =>
          ( Mapped_To_Upper => Small_Character'val(  95 ),
            Mapped_To_Lower => Small_Character'val(  95 ),
            Mapped_To_Basic => Small_Character'val(  95 ) ),
        Character'val(  96 ) =>
          ( Mapped_To_Upper => Small_Character'val(  96 ),
            Mapped_To_Lower => Small_Character'val(  96 ),
            Mapped_To_Basic => Small_Character'val(  96 ) ),
        Character'val(  97 ) =>
          ( Mapped_To_Upper => Small_Character'val(  65 ),
            Mapped_To_Lower => Small_Character'val(  97 ),
            Mapped_To_Basic => Small_Character'val(  97 ) ),
        Character'val(  98 ) =>
          ( Mapped_To_Upper => Small_Character'val(  66 ),
            Mapped_To_Lower => Small_Character'val(  98 ),
            Mapped_To_Basic => Small_Character'val(  98 ) ),
        Character'val(  99 ) =>
          ( Mapped_To_Upper => Small_Character'val(  67 ),
            Mapped_To_Lower => Small_Character'val(  99 ),
            Mapped_To_Basic => Small_Character'val(  99 ) ),
        Character'val( 100 ) =>
          ( Mapped_To_Upper => Small_Character'val(  68 ),
            Mapped_To_Lower => Small_Character'val( 100 ),
            Mapped_To_Basic => Small_Character'val( 100 ) ),
        Character'val( 101 ) =>
          ( Mapped_To_Upper => Small_Character'val(  69 ),
            Mapped_To_Lower => Small_Character'val( 101 ),
            Mapped_To_Basic => Small_Character'val( 101 ) ),
        Character'val( 102 ) =>
          ( Mapped_To_Upper => Small_Character'val(  70 ),
            Mapped_To_Lower => Small_Character'val( 102 ),
            Mapped_To_Basic => Small_Character'val( 102 ) ),
        Character'val( 103 ) =>
          ( Mapped_To_Upper => Small_Character'val(  71 ),
            Mapped_To_Lower => Small_Character'val( 103 ),
            Mapped_To_Basic => Small_Character'val( 103 ) ),
        Character'val( 104 ) =>
          ( Mapped_To_Upper => Small_Character'val(  72 ),
            Mapped_To_Lower => Small_Character'val( 104 ),
            Mapped_To_Basic => Small_Character'val( 104 ) ),
        Character'val( 105 ) =>
          ( Mapped_To_Upper => Small_Character'val(  73 ),
            Mapped_To_Lower => Small_Character'val( 105 ),
            Mapped_To_Basic => Small_Character'val( 105 ) ),
        Character'val( 106 ) =>
          ( Mapped_To_Upper => Small_Character'val(  74 ),
            Mapped_To_Lower => Small_Character'val( 106 ),
            Mapped_To_Basic => Small_Character'val( 106 ) ),
        Character'val( 107 ) =>
          ( Mapped_To_Upper => Small_Character'val(  75 ),
            Mapped_To_Lower => Small_Character'val( 107 ),
            Mapped_To_Basic => Small_Character'val( 107 ) ),
        Character'val( 108 ) =>
          ( Mapped_To_Upper => Small_Character'val(  76 ),
            Mapped_To_Lower => Small_Character'val( 108 ),
            Mapped_To_Basic => Small_Character'val( 108 ) ),
        Character'val( 109 ) =>
          ( Mapped_To_Upper => Small_Character'val(  77 ),
            Mapped_To_Lower => Small_Character'val( 109 ),
            Mapped_To_Basic => Small_Character'val( 109 ) ),
        Character'val( 110 ) =>
          ( Mapped_To_Upper => Small_Character'val(  78 ),
            Mapped_To_Lower => Small_Character'val( 110 ),
            Mapped_To_Basic => Small_Character'val( 110 ) ),
        Character'val( 111 ) =>
          ( Mapped_To_Upper => Small_Character'val(  79 ),
            Mapped_To_Lower => Small_Character'val( 111 ),
            Mapped_To_Basic => Small_Character'val( 111 ) ),
        Character'val( 112 ) =>
          ( Mapped_To_Upper => Small_Character'val(  80 ),
            Mapped_To_Lower => Small_Character'val( 112 ),
            Mapped_To_Basic => Small_Character'val( 112 ) ),
        Character'val( 113 ) =>
          ( Mapped_To_Upper => Small_Character'val(  81 ),
            Mapped_To_Lower => Small_Character'val( 113 ),
            Mapped_To_Basic => Small_Character'val( 113 ) ),
        Character'val( 114 ) =>
          ( Mapped_To_Upper => Small_Character'val(  82 ),
            Mapped_To_Lower => Small_Character'val( 114 ),
            Mapped_To_Basic => Small_Character'val( 114 ) ),
        Character'val( 115 ) =>
          ( Mapped_To_Upper => Small_Character'val(  83 ),
            Mapped_To_Lower => Small_Character'val( 115 ),
            Mapped_To_Basic => Small_Character'val( 115 ) ),
        Character'val( 116 ) =>
          ( Mapped_To_Upper => Small_Character'val(  84 ),
            Mapped_To_Lower => Small_Character'val( 116 ),
            Mapped_To_Basic => Small_Character'val( 116 ) ),
        Character'val( 117 ) =>
          ( Mapped_To_Upper => Small_Character'val(  85 ),
            Mapped_To_Lower => Small_Character'val( 117 ),
            Mapped_To_Basic => Small_Character'val( 117 ) ),
        Character'val( 118 ) =>
          ( Mapped_To_Upper => Small_Character'val(  86 ),
            Mapped_To_Lower => Small_Character'val( 118 ),
            Mapped_To_Basic => Small_Character'val( 118 ) ),
        Character'val( 119 ) =>
          ( Mapped_To_Upper => Small_Character'val(  87 ),
            Mapped_To_Lower => Small_Character'val( 119 ),
            Mapped_To_Basic => Small_Character'val( 119 ) ),
        Character'val( 120 ) =>
          ( Mapped_To_Upper => Small_Character'val(  88 ),
            Mapped_To_Lower => Small_Character'val( 120 ),
            Mapped_To_Basic => Small_Character'val( 120 ) ),
        Character'val( 121 ) =>
          ( Mapped_To_Upper => Small_Character'val(  89 ),
            Mapped_To_Lower => Small_Character'val( 121 ),
            Mapped_To_Basic => Small_Character'val( 121 ) ),
        Character'val( 122 ) =>
          ( Mapped_To_Upper => Small_Character'val(  90 ),
            Mapped_To_Lower => Small_Character'val( 122 ),
            Mapped_To_Basic => Small_Character'val( 122 ) ),
        Character'val( 123 ) =>
          ( Mapped_To_Upper => Small_Character'val( 123 ),
            Mapped_To_Lower => Small_Character'val( 123 ),
            Mapped_To_Basic => Small_Character'val( 123 ) ),
        Character'val( 124 ) =>
          ( Mapped_To_Upper => Small_Character'val( 124 ),
            Mapped_To_Lower => Small_Character'val( 124 ),
            Mapped_To_Basic => Small_Character'val( 124 ) ),
        Character'val( 125 ) =>
          ( Mapped_To_Upper => Small_Character'val( 125 ),
            Mapped_To_Lower => Small_Character'val( 125 ),
            Mapped_To_Basic => Small_Character'val( 125 ) ),
        Character'val( 126 ) =>
          ( Mapped_To_Upper => Small_Character'val( 126 ),
            Mapped_To_Lower => Small_Character'val( 126 ),
            Mapped_To_Basic => Small_Character'val( 126 ) ),
        Character'val( 127 ) =>
          ( Mapped_To_Upper => Small_Character'val( 127 ),
            Mapped_To_Lower => Small_Character'val( 127 ),
            Mapped_To_Basic => Small_Character'val( 127 ) ),
        Character'val( 128 ) =>
          ( Mapped_To_Upper => Small_Character'val( 128 ),
            Mapped_To_Lower => Small_Character'val( 128 ),
            Mapped_To_Basic => Small_Character'val( 128 ) ),
        Character'val( 129 ) =>
          ( Mapped_To_Upper => Small_Character'val( 129 ),
            Mapped_To_Lower => Small_Character'val( 129 ),
            Mapped_To_Basic => Small_Character'val( 129 ) ),
        Character'val( 130 ) =>
          ( Mapped_To_Upper => Small_Character'val( 130 ),
            Mapped_To_Lower => Small_Character'val( 130 ),
            Mapped_To_Basic => Small_Character'val( 130 ) ),
        Character'val( 131 ) =>
          ( Mapped_To_Upper => Small_Character'val( 131 ),
            Mapped_To_Lower => Small_Character'val( 131 ),
            Mapped_To_Basic => Small_Character'val( 131 ) ),
        Character'val( 132 ) =>
          ( Mapped_To_Upper => Small_Character'val( 132 ),
            Mapped_To_Lower => Small_Character'val( 132 ),
            Mapped_To_Basic => Small_Character'val( 132 ) ),
        Character'val( 133 ) =>
          ( Mapped_To_Upper => Small_Character'val( 133 ),
            Mapped_To_Lower => Small_Character'val( 133 ),
            Mapped_To_Basic => Small_Character'val( 133 ) ),
        Character'val( 134 ) =>
          ( Mapped_To_Upper => Small_Character'val( 134 ),
            Mapped_To_Lower => Small_Character'val( 134 ),
            Mapped_To_Basic => Small_Character'val( 134 ) ),
        Character'val( 135 ) =>
          ( Mapped_To_Upper => Small_Character'val( 135 ),
            Mapped_To_Lower => Small_Character'val( 135 ),
            Mapped_To_Basic => Small_Character'val( 135 ) ),
        Character'val( 136 ) =>
          ( Mapped_To_Upper => Small_Character'val( 136 ),
            Mapped_To_Lower => Small_Character'val( 136 ),
            Mapped_To_Basic => Small_Character'val( 136 ) ),
        Character'val( 137 ) =>
          ( Mapped_To_Upper => Small_Character'val( 137 ),
            Mapped_To_Lower => Small_Character'val( 137 ),
            Mapped_To_Basic => Small_Character'val( 137 ) ),
        Character'val( 138 ) =>
          ( Mapped_To_Upper => Small_Character'val( 138 ),
            Mapped_To_Lower => Small_Character'val( 138 ),
            Mapped_To_Basic => Small_Character'val( 138 ) ),
        Character'val( 139 ) =>
          ( Mapped_To_Upper => Small_Character'val( 139 ),
            Mapped_To_Lower => Small_Character'val( 139 ),
            Mapped_To_Basic => Small_Character'val( 139 ) ),
        Character'val( 140 ) =>
          ( Mapped_To_Upper => Small_Character'val( 140 ),
            Mapped_To_Lower => Small_Character'val( 140 ),
            Mapped_To_Basic => Small_Character'val( 140 ) ),
        Character'val( 141 ) =>
          ( Mapped_To_Upper => Small_Character'val( 141 ),
            Mapped_To_Lower => Small_Character'val( 141 ),
            Mapped_To_Basic => Small_Character'val( 141 ) ),
        Character'val( 142 ) =>
          ( Mapped_To_Upper => Small_Character'val( 142 ),
            Mapped_To_Lower => Small_Character'val( 142 ),
            Mapped_To_Basic => Small_Character'val( 142 ) ),
        Character'val( 143 ) =>
          ( Mapped_To_Upper => Small_Character'val( 143 ),
            Mapped_To_Lower => Small_Character'val( 143 ),
            Mapped_To_Basic => Small_Character'val( 143 ) ),
        Character'val( 144 ) =>
          ( Mapped_To_Upper => Small_Character'val( 144 ),
            Mapped_To_Lower => Small_Character'val( 144 ),
            Mapped_To_Basic => Small_Character'val( 144 ) ),
        Character'val( 145 ) =>
          ( Mapped_To_Upper => Small_Character'val( 145 ),
            Mapped_To_Lower => Small_Character'val( 145 ),
            Mapped_To_Basic => Small_Character'val( 145 ) ),
        Character'val( 146 ) =>
          ( Mapped_To_Upper => Small_Character'val( 146 ),
            Mapped_To_Lower => Small_Character'val( 146 ),
            Mapped_To_Basic => Small_Character'val( 146 ) ),
        Character'val( 147 ) =>
          ( Mapped_To_Upper => Small_Character'val( 147 ),
            Mapped_To_Lower => Small_Character'val( 147 ),
            Mapped_To_Basic => Small_Character'val( 147 ) ),
        Character'val( 148 ) =>
          ( Mapped_To_Upper => Small_Character'val( 148 ),
            Mapped_To_Lower => Small_Character'val( 148 ),
            Mapped_To_Basic => Small_Character'val( 148 ) ),
        Character'val( 149 ) =>
          ( Mapped_To_Upper => Small_Character'val( 149 ),
            Mapped_To_Lower => Small_Character'val( 149 ),
            Mapped_To_Basic => Small_Character'val( 149 ) ),
        Character'val( 150 ) =>
          ( Mapped_To_Upper => Small_Character'val( 150 ),
            Mapped_To_Lower => Small_Character'val( 150 ),
            Mapped_To_Basic => Small_Character'val( 150 ) ),
        Character'val( 151 ) =>
          ( Mapped_To_Upper => Small_Character'val( 151 ),
            Mapped_To_Lower => Small_Character'val( 151 ),
            Mapped_To_Basic => Small_Character'val( 151 ) ),
        Character'val( 152 ) =>
          ( Mapped_To_Upper => Small_Character'val( 152 ),
            Mapped_To_Lower => Small_Character'val( 152 ),
            Mapped_To_Basic => Small_Character'val( 152 ) ),
        Character'val( 153 ) =>
          ( Mapped_To_Upper => Small_Character'val( 153 ),
            Mapped_To_Lower => Small_Character'val( 153 ),
            Mapped_To_Basic => Small_Character'val( 153 ) ),
        Character'val( 154 ) =>
          ( Mapped_To_Upper => Small_Character'val( 154 ),
            Mapped_To_Lower => Small_Character'val( 154 ),
            Mapped_To_Basic => Small_Character'val( 154 ) ),
        Character'val( 155 ) =>
          ( Mapped_To_Upper => Small_Character'val( 155 ),
            Mapped_To_Lower => Small_Character'val( 155 ),
            Mapped_To_Basic => Small_Character'val( 155 ) ),
        Character'val( 156 ) =>
          ( Mapped_To_Upper => Small_Character'val( 156 ),
            Mapped_To_Lower => Small_Character'val( 156 ),
            Mapped_To_Basic => Small_Character'val( 156 ) ),
        Character'val( 157 ) =>
          ( Mapped_To_Upper => Small_Character'val( 157 ),
            Mapped_To_Lower => Small_Character'val( 157 ),
            Mapped_To_Basic => Small_Character'val( 157 ) ),
        Character'val( 158 ) =>
          ( Mapped_To_Upper => Small_Character'val( 158 ),
            Mapped_To_Lower => Small_Character'val( 158 ),
            Mapped_To_Basic => Small_Character'val( 158 ) ),
        Character'val( 159 ) =>
          ( Mapped_To_Upper => Small_Character'val( 159 ),
            Mapped_To_Lower => Small_Character'val( 159 ),
            Mapped_To_Basic => Small_Character'val( 159 ) ),
        Character'val( 160 ) =>
          ( Mapped_To_Upper => Small_Character'val( 160 ),
            Mapped_To_Lower => Small_Character'val( 160 ),
            Mapped_To_Basic => Small_Character'val( 160 ) ),
        Character'val( 161 ) =>
          ( Mapped_To_Upper => Small_Character'val( 161 ),
            Mapped_To_Lower => Small_Character'val( 161 ),
            Mapped_To_Basic => Small_Character'val( 161 ) ),
        Character'val( 162 ) =>
          ( Mapped_To_Upper => Small_Character'val( 162 ),
            Mapped_To_Lower => Small_Character'val( 162 ),
            Mapped_To_Basic => Small_Character'val( 162 ) ),
        Character'val( 163 ) =>
          ( Mapped_To_Upper => Small_Character'val( 163 ),
            Mapped_To_Lower => Small_Character'val( 163 ),
            Mapped_To_Basic => Small_Character'val( 163 ) ),
        Character'val( 164 ) =>
          ( Mapped_To_Upper => Small_Character'val( 164 ),
            Mapped_To_Lower => Small_Character'val( 164 ),
            Mapped_To_Basic => Small_Character'val( 164 ) ),
        Character'val( 165 ) =>
          ( Mapped_To_Upper => Small_Character'val( 165 ),
            Mapped_To_Lower => Small_Character'val( 165 ),
            Mapped_To_Basic => Small_Character'val( 165 ) ),
        Character'val( 166 ) =>
          ( Mapped_To_Upper => Small_Character'val( 166 ),
            Mapped_To_Lower => Small_Character'val( 166 ),
            Mapped_To_Basic => Small_Character'val( 166 ) ),
        Character'val( 167 ) =>
          ( Mapped_To_Upper => Small_Character'val( 167 ),
            Mapped_To_Lower => Small_Character'val( 167 ),
            Mapped_To_Basic => Small_Character'val( 167 ) ),
        Character'val( 168 ) =>
          ( Mapped_To_Upper => Small_Character'val( 168 ),
            Mapped_To_Lower => Small_Character'val( 168 ),
            Mapped_To_Basic => Small_Character'val( 168 ) ),
        Character'val( 169 ) =>
          ( Mapped_To_Upper => Small_Character'val( 169 ),
            Mapped_To_Lower => Small_Character'val( 169 ),
            Mapped_To_Basic => Small_Character'val( 169 ) ),
        Character'val( 170 ) =>
          ( Mapped_To_Upper => Small_Character'val( 170 ),
            Mapped_To_Lower => Small_Character'val( 170 ),
            Mapped_To_Basic => Small_Character'val( 170 ) ),
        Character'val( 171 ) =>
          ( Mapped_To_Upper => Small_Character'val( 171 ),
            Mapped_To_Lower => Small_Character'val( 171 ),
            Mapped_To_Basic => Small_Character'val( 171 ) ),
        Character'val( 172 ) =>
          ( Mapped_To_Upper => Small_Character'val( 172 ),
            Mapped_To_Lower => Small_Character'val( 172 ),
            Mapped_To_Basic => Small_Character'val( 172 ) ),
        Character'val( 173 ) =>
          ( Mapped_To_Upper => Small_Character'val( 173 ),
            Mapped_To_Lower => Small_Character'val( 173 ),
            Mapped_To_Basic => Small_Character'val( 173 ) ),
        Character'val( 174 ) =>
          ( Mapped_To_Upper => Small_Character'val( 174 ),
            Mapped_To_Lower => Small_Character'val( 174 ),
            Mapped_To_Basic => Small_Character'val( 174 ) ),
        Character'val( 175 ) =>
          ( Mapped_To_Upper => Small_Character'val( 175 ),
            Mapped_To_Lower => Small_Character'val( 175 ),
            Mapped_To_Basic => Small_Character'val( 175 ) ),
        Character'val( 176 ) =>
          ( Mapped_To_Upper => Small_Character'val( 176 ),
            Mapped_To_Lower => Small_Character'val( 176 ),
            Mapped_To_Basic => Small_Character'val( 176 ) ),
        Character'val( 177 ) =>
          ( Mapped_To_Upper => Small_Character'val( 177 ),
            Mapped_To_Lower => Small_Character'val( 177 ),
            Mapped_To_Basic => Small_Character'val( 177 ) ),
        Character'val( 178 ) =>
          ( Mapped_To_Upper => Small_Character'val( 178 ),
            Mapped_To_Lower => Small_Character'val( 178 ),
            Mapped_To_Basic => Small_Character'val( 178 ) ),
        Character'val( 179 ) =>
          ( Mapped_To_Upper => Small_Character'val( 179 ),
            Mapped_To_Lower => Small_Character'val( 179 ),
            Mapped_To_Basic => Small_Character'val( 179 ) ),
        Character'val( 180 ) =>
          ( Mapped_To_Upper => Small_Character'val( 180 ),
            Mapped_To_Lower => Small_Character'val( 180 ),
            Mapped_To_Basic => Small_Character'val( 180 ) ),
        Character'val( 181 ) =>
          ( Mapped_To_Upper => Small_Character'val( 181 ),
            Mapped_To_Lower => Small_Character'val( 181 ),
            Mapped_To_Basic => Small_Character'val( 181 ) ),
        Character'val( 182 ) =>
          ( Mapped_To_Upper => Small_Character'val( 182 ),
            Mapped_To_Lower => Small_Character'val( 182 ),
            Mapped_To_Basic => Small_Character'val( 182 ) ),
        Character'val( 183 ) =>
          ( Mapped_To_Upper => Small_Character'val( 183 ),
            Mapped_To_Lower => Small_Character'val( 183 ),
            Mapped_To_Basic => Small_Character'val( 183 ) ),
        Character'val( 184 ) =>
          ( Mapped_To_Upper => Small_Character'val( 184 ),
            Mapped_To_Lower => Small_Character'val( 184 ),
            Mapped_To_Basic => Small_Character'val( 184 ) ),
        Character'val( 185 ) =>
          ( Mapped_To_Upper => Small_Character'val( 185 ),
            Mapped_To_Lower => Small_Character'val( 185 ),
            Mapped_To_Basic => Small_Character'val( 185 ) ),
        Character'val( 186 ) =>
          ( Mapped_To_Upper => Small_Character'val( 186 ),
            Mapped_To_Lower => Small_Character'val( 186 ),
            Mapped_To_Basic => Small_Character'val( 186 ) ),
        Character'val( 187 ) =>
          ( Mapped_To_Upper => Small_Character'val( 187 ),
            Mapped_To_Lower => Small_Character'val( 187 ),
            Mapped_To_Basic => Small_Character'val( 187 ) ),
        Character'val( 188 ) =>
          ( Mapped_To_Upper => Small_Character'val( 188 ),
            Mapped_To_Lower => Small_Character'val( 188 ),
            Mapped_To_Basic => Small_Character'val( 188 ) ),
        Character'val( 189 ) =>
          ( Mapped_To_Upper => Small_Character'val( 189 ),
            Mapped_To_Lower => Small_Character'val( 189 ),
            Mapped_To_Basic => Small_Character'val( 189 ) ),
        Character'val( 190 ) =>
          ( Mapped_To_Upper => Small_Character'val( 190 ),
            Mapped_To_Lower => Small_Character'val( 190 ),
            Mapped_To_Basic => Small_Character'val( 190 ) ),
        Character'val( 191 ) =>
          ( Mapped_To_Upper => Small_Character'val( 191 ),
            Mapped_To_Lower => Small_Character'val( 191 ),
            Mapped_To_Basic => Small_Character'val( 191 ) ),
        Character'val( 192 ) =>
          ( Mapped_To_Upper => Small_Character'val( 192 ),
            Mapped_To_Lower => Small_Character'val( 224 ),
            Mapped_To_Basic => Small_Character'val(  65 ) ),
        Character'val( 193 ) =>
          ( Mapped_To_Upper => Small_Character'val( 193 ),
            Mapped_To_Lower => Small_Character'val( 225 ),
            Mapped_To_Basic => Small_Character'val(  65 ) ),
        Character'val( 194 ) =>
          ( Mapped_To_Upper => Small_Character'val( 194 ),
            Mapped_To_Lower => Small_Character'val( 226 ),
            Mapped_To_Basic => Small_Character'val(  65 ) ),
        Character'val( 195 ) =>
          ( Mapped_To_Upper => Small_Character'val( 195 ),
            Mapped_To_Lower => Small_Character'val( 227 ),
            Mapped_To_Basic => Small_Character'val(  65 ) ),
        Character'val( 196 ) =>
          ( Mapped_To_Upper => Small_Character'val( 196 ),
            Mapped_To_Lower => Small_Character'val( 228 ),
            Mapped_To_Basic => Small_Character'val(  65 ) ),
        Character'val( 197 ) =>
          ( Mapped_To_Upper => Small_Character'val( 197 ),
            Mapped_To_Lower => Small_Character'val( 229 ),
            Mapped_To_Basic => Small_Character'val(  65 ) ),
        Character'val( 198 ) =>
          ( Mapped_To_Upper => Small_Character'val( 198 ),
            Mapped_To_Lower => Small_Character'val( 230 ),
            Mapped_To_Basic => Small_Character'val( 198 ) ),
        Character'val( 199 ) =>
          ( Mapped_To_Upper => Small_Character'val( 199 ),
            Mapped_To_Lower => Small_Character'val( 231 ),
            Mapped_To_Basic => Small_Character'val(  67 ) ),
        Character'val( 200 ) =>
          ( Mapped_To_Upper => Small_Character'val( 200 ),
            Mapped_To_Lower => Small_Character'val( 232 ),
            Mapped_To_Basic => Small_Character'val(  69 ) ),
        Character'val( 201 ) =>
          ( Mapped_To_Upper => Small_Character'val( 201 ),
            Mapped_To_Lower => Small_Character'val( 233 ),
            Mapped_To_Basic => Small_Character'val(  69 ) ),
        Character'val( 202 ) =>
          ( Mapped_To_Upper => Small_Character'val( 202 ),
            Mapped_To_Lower => Small_Character'val( 234 ),
            Mapped_To_Basic => Small_Character'val(  69 ) ),
        Character'val( 203 ) =>
          ( Mapped_To_Upper => Small_Character'val( 203 ),
            Mapped_To_Lower => Small_Character'val( 235 ),
            Mapped_To_Basic => Small_Character'val(  69 ) ),
        Character'val( 204 ) =>
          ( Mapped_To_Upper => Small_Character'val( 204 ),
            Mapped_To_Lower => Small_Character'val( 236 ),
            Mapped_To_Basic => Small_Character'val(  73 ) ),
        Character'val( 205 ) =>
          ( Mapped_To_Upper => Small_Character'val( 205 ),
            Mapped_To_Lower => Small_Character'val( 237 ),
            Mapped_To_Basic => Small_Character'val(  73 ) ),
        Character'val( 206 ) =>
          ( Mapped_To_Upper => Small_Character'val( 206 ),
            Mapped_To_Lower => Small_Character'val( 238 ),
            Mapped_To_Basic => Small_Character'val(  73 ) ),
        Character'val( 207 ) =>
          ( Mapped_To_Upper => Small_Character'val( 207 ),
            Mapped_To_Lower => Small_Character'val( 239 ),
            Mapped_To_Basic => Small_Character'val(  73 ) ),
        Character'val( 208 ) =>
          ( Mapped_To_Upper => Small_Character'val( 208 ),
            Mapped_To_Lower => Small_Character'val( 240 ),
            Mapped_To_Basic => Small_Character'val( 208 ) ),
        Character'val( 209 ) =>
          ( Mapped_To_Upper => Small_Character'val( 209 ),
            Mapped_To_Lower => Small_Character'val( 241 ),
            Mapped_To_Basic => Small_Character'val(  78 ) ),
        Character'val( 210 ) =>
          ( Mapped_To_Upper => Small_Character'val( 210 ),
            Mapped_To_Lower => Small_Character'val( 242 ),
            Mapped_To_Basic => Small_Character'val(  79 ) ),
        Character'val( 211 ) =>
          ( Mapped_To_Upper => Small_Character'val( 211 ),
            Mapped_To_Lower => Small_Character'val( 243 ),
            Mapped_To_Basic => Small_Character'val(  79 ) ),
        Character'val( 212 ) =>
          ( Mapped_To_Upper => Small_Character'val( 212 ),
            Mapped_To_Lower => Small_Character'val( 244 ),
            Mapped_To_Basic => Small_Character'val(  79 ) ),
        Character'val( 213 ) =>
          ( Mapped_To_Upper => Small_Character'val( 213 ),
            Mapped_To_Lower => Small_Character'val( 245 ),
            Mapped_To_Basic => Small_Character'val(  79 ) ),
        Character'val( 214 ) =>
          ( Mapped_To_Upper => Small_Character'val( 214 ),
            Mapped_To_Lower => Small_Character'val( 246 ),
            Mapped_To_Basic => Small_Character'val(  79 ) ),
        Character'val( 215 ) =>
          ( Mapped_To_Upper => Small_Character'val( 215 ),
            Mapped_To_Lower => Small_Character'val( 215 ),
            Mapped_To_Basic => Small_Character'val( 215 ) ),
        Character'val( 216 ) =>
          ( Mapped_To_Upper => Small_Character'val( 216 ),
            Mapped_To_Lower => Small_Character'val( 248 ),
            Mapped_To_Basic => Small_Character'val(  79 ) ),
        Character'val( 217 ) =>
          ( Mapped_To_Upper => Small_Character'val( 217 ),
            Mapped_To_Lower => Small_Character'val( 249 ),
            Mapped_To_Basic => Small_Character'val(  85 ) ),
        Character'val( 218 ) =>
          ( Mapped_To_Upper => Small_Character'val( 218 ),
            Mapped_To_Lower => Small_Character'val( 250 ),
            Mapped_To_Basic => Small_Character'val(  85 ) ),
        Character'val( 219 ) =>
          ( Mapped_To_Upper => Small_Character'val( 219 ),
            Mapped_To_Lower => Small_Character'val( 251 ),
            Mapped_To_Basic => Small_Character'val(  85 ) ),
        Character'val( 220 ) =>
          ( Mapped_To_Upper => Small_Character'val( 220 ),
            Mapped_To_Lower => Small_Character'val( 252 ),
            Mapped_To_Basic => Small_Character'val(  85 ) ),
        Character'val( 221 ) =>
          ( Mapped_To_Upper => Small_Character'val( 221 ),
            Mapped_To_Lower => Small_Character'val( 253 ),
            Mapped_To_Basic => Small_Character'val(  89 ) ),
        Character'val( 222 ) =>
          ( Mapped_To_Upper => Small_Character'val( 222 ),
            Mapped_To_Lower => Small_Character'val( 254 ),
            Mapped_To_Basic => Small_Character'val( 222 ) ),
        Character'val( 223 ) =>
          ( Mapped_To_Upper => Small_Character'val( 223 ),
            Mapped_To_Lower => Small_Character'val( 223 ),
            Mapped_To_Basic => Small_Character'val( 121 ) ),
        Character'val( 224 ) =>
          ( Mapped_To_Upper => Small_Character'val( 192 ),
            Mapped_To_Lower => Small_Character'val( 224 ),
            Mapped_To_Basic => Small_Character'val(  97 ) ),
        Character'val( 225 ) =>
          ( Mapped_To_Upper => Small_Character'val( 193 ),
            Mapped_To_Lower => Small_Character'val( 225 ),
            Mapped_To_Basic => Small_Character'val(  97 ) ),
        Character'val( 226 ) =>
          ( Mapped_To_Upper => Small_Character'val( 194 ),
            Mapped_To_Lower => Small_Character'val( 226 ),
            Mapped_To_Basic => Small_Character'val(  97 ) ),
        Character'val( 227 ) =>
          ( Mapped_To_Upper => Small_Character'val( 195 ),
            Mapped_To_Lower => Small_Character'val( 227 ),
            Mapped_To_Basic => Small_Character'val(  97 ) ),
        Character'val( 228 ) =>
          ( Mapped_To_Upper => Small_Character'val( 196 ),
            Mapped_To_Lower => Small_Character'val( 228 ),
            Mapped_To_Basic => Small_Character'val(  97 ) ),
        Character'val( 229 ) =>
          ( Mapped_To_Upper => Small_Character'val( 197 ),
            Mapped_To_Lower => Small_Character'val( 229 ),
            Mapped_To_Basic => Small_Character'val(  97 ) ),
        Character'val( 230 ) =>
          ( Mapped_To_Upper => Small_Character'val( 198 ),
            Mapped_To_Lower => Small_Character'val( 230 ),
            Mapped_To_Basic => Small_Character'val( 230 ) ),
        Character'val( 231 ) =>
          ( Mapped_To_Upper => Small_Character'val( 199 ),
            Mapped_To_Lower => Small_Character'val( 231 ),
            Mapped_To_Basic => Small_Character'val(  99 ) ),
        Character'val( 232 ) =>
          ( Mapped_To_Upper => Small_Character'val( 200 ),
            Mapped_To_Lower => Small_Character'val( 232 ),
            Mapped_To_Basic => Small_Character'val( 101 ) ),
        Character'val( 233 ) =>
          ( Mapped_To_Upper => Small_Character'val( 201 ),
            Mapped_To_Lower => Small_Character'val( 233 ),
            Mapped_To_Basic => Small_Character'val( 101 ) ),
        Character'val( 234 ) =>
          ( Mapped_To_Upper => Small_Character'val( 202 ),
            Mapped_To_Lower => Small_Character'val( 234 ),
            Mapped_To_Basic => Small_Character'val( 101 ) ),
        Character'val( 235 ) =>
          ( Mapped_To_Upper => Small_Character'val( 203 ),
            Mapped_To_Lower => Small_Character'val( 235 ),
            Mapped_To_Basic => Small_Character'val( 101 ) ),
        Character'val( 236 ) =>
          ( Mapped_To_Upper => Small_Character'val( 204 ),
            Mapped_To_Lower => Small_Character'val( 236 ),
            Mapped_To_Basic => Small_Character'val( 105 ) ),
        Character'val( 237 ) =>
          ( Mapped_To_Upper => Small_Character'val( 205 ),
            Mapped_To_Lower => Small_Character'val( 237 ),
            Mapped_To_Basic => Small_Character'val( 105 ) ),
        Character'val( 238 ) =>
          ( Mapped_To_Upper => Small_Character'val( 206 ),
            Mapped_To_Lower => Small_Character'val( 238 ),
            Mapped_To_Basic => Small_Character'val( 105 ) ),
        Character'val( 239 ) =>
          ( Mapped_To_Upper => Small_Character'val( 207 ),
            Mapped_To_Lower => Small_Character'val( 239 ),
            Mapped_To_Basic => Small_Character'val( 105 ) ),
        Character'val( 240 ) =>
          ( Mapped_To_Upper => Small_Character'val( 208 ),
            Mapped_To_Lower => Small_Character'val( 240 ),
            Mapped_To_Basic => Small_Character'val( 240 ) ),
        Character'val( 241 ) =>
          ( Mapped_To_Upper => Small_Character'val( 209 ),
            Mapped_To_Lower => Small_Character'val( 241 ),
            Mapped_To_Basic => Small_Character'val( 110 ) ),
        Character'val( 242 ) =>
          ( Mapped_To_Upper => Small_Character'val( 210 ),
            Mapped_To_Lower => Small_Character'val( 242 ),
            Mapped_To_Basic => Small_Character'val( 111 ) ),
        Character'val( 243 ) =>
          ( Mapped_To_Upper => Small_Character'val( 211 ),
            Mapped_To_Lower => Small_Character'val( 243 ),
            Mapped_To_Basic => Small_Character'val( 111 ) ),
        Character'val( 244 ) =>
          ( Mapped_To_Upper => Small_Character'val( 212 ),
            Mapped_To_Lower => Small_Character'val( 244 ),
            Mapped_To_Basic => Small_Character'val( 111 ) ),
        Character'val( 245 ) =>
          ( Mapped_To_Upper => Small_Character'val( 213 ),
            Mapped_To_Lower => Small_Character'val( 245 ),
            Mapped_To_Basic => Small_Character'val( 111 ) ),
        Character'val( 246 ) =>
          ( Mapped_To_Upper => Small_Character'val( 214 ),
            Mapped_To_Lower => Small_Character'val( 246 ),
            Mapped_To_Basic => Small_Character'val( 111 ) ),
        Character'val( 247 ) =>
          ( Mapped_To_Upper => Small_Character'val( 247 ),
            Mapped_To_Lower => Small_Character'val( 247 ),
            Mapped_To_Basic => Small_Character'val( 247 ) ),
        Character'val( 248 ) =>
          ( Mapped_To_Upper => Small_Character'val( 216 ),
            Mapped_To_Lower => Small_Character'val( 248 ),
            Mapped_To_Basic => Small_Character'val( 111 ) ),
        Character'val( 249 ) =>
          ( Mapped_To_Upper => Small_Character'val( 217 ),
            Mapped_To_Lower => Small_Character'val( 249 ),
            Mapped_To_Basic => Small_Character'val( 117 ) ),
        Character'val( 250 ) =>
          ( Mapped_To_Upper => Small_Character'val( 218 ),
            Mapped_To_Lower => Small_Character'val( 250 ),
            Mapped_To_Basic => Small_Character'val( 117 ) ),
        Character'val( 251 ) =>
          ( Mapped_To_Upper => Small_Character'val( 219 ),
            Mapped_To_Lower => Small_Character'val( 251 ),
            Mapped_To_Basic => Small_Character'val( 117 ) ),
        Character'val( 252 ) =>
          ( Mapped_To_Upper => Small_Character'val( 220 ),
            Mapped_To_Lower => Small_Character'val( 252 ),
            Mapped_To_Basic => Small_Character'val( 117 ) ),
        Character'val( 253 ) =>
          ( Mapped_To_Upper => Small_Character'val( 221 ),
            Mapped_To_Lower => Small_Character'val( 253 ),
            Mapped_To_Basic => Small_Character'val( 121 ) ),
        Character'val( 254 ) =>
          ( Mapped_To_Upper => Small_Character'val( 222 ),
            Mapped_To_Lower => Small_Character'val( 254 ),
            Mapped_To_Basic => Small_Character'val( 254 ) ),
        Character'val( 255 ) =>
          ( Mapped_To_Upper => Small_Character'val( 255 ),
            Mapped_To_Lower => Small_Character'val( 255 ),
            Mapped_To_Basic => Small_Character'val( 121 ) )
      );

--Character classification functions

    function Is_Control (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Control_Char;
    end Is_Control;

    function Is_Graphic (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Graphic_Char;
    end Is_Graphic;

    function Is_Letter (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Letter_Char;
    end Is_Letter;

    function Is_Lower (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Lower_Char;
    end Is_Lower;

    function Is_Upper (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Upper_Char;
    end Is_Upper;

    function Is_Basic (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Basic_Char;
    end Is_Basic;

    function Is_Digit (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Digit_Char;
    end Is_Digit;

    function Is_Hexadecimal_Digit (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Hexadecimal_Digit_Char;
    end Is_Hexadecimal_Digit;

    function Is_Alphanumeric      (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Alphanumeric_Char;
    end Is_Alphanumeric;

    function Is_Special (Item : in Character) return Boolean is
    begin
        return Ctype( Item ).Is_Special_Char;
    end Is_Special;

--Conversion functions for Character and String

    function To_Lower (Item : in Character) return Character is
    begin
	return Character( Cmap( Item ).Mapped_To_Lower );
    end To_Lower;

    function To_Upper (Item : in Character) return Character is
    begin
	return Character( Cmap( Item ).Mapped_To_Upper );
    end To_Upper;

    function To_Basic (Item : in Character) return Character is
    begin
	return Character( Cmap( Item ).Mapped_To_Basic );
    end To_Basic;

    function To_Lower (Item : in String) return String is
	Result : String( Item'Range );
    begin
	for Index in Item'Range loop
	    Result( Index ) :=
	      Character( Cmap( Item( Index ) ).Mapped_To_Lower );
	end loop;

	return Result;
    end To_Lower;

    function To_Upper (Item : in String) return String is
	Result : String( Item'Range );
    begin
	for Index in Item'Range loop
	    Result( Index ) :=
	      Character( Cmap( Item( Index ) ).Mapped_To_Upper );
	end loop;

	return Result;
    end To_Upper;

    function To_Basic (Item : in String) return String is
	Result : String( Item'Range );
    begin
	for Index in Item'Range loop
	    Result( Index ) :=
	      Character( Cmap( Item( Index ) ).Mapped_To_Basic );
	end loop;

	return Result;
    end To_Basic;

--Classifications of and conversions between Character and ISO 646

    function Is_ISO_646 (Item : in Character) return Boolean is
    begin
        return Item in ISO_646;
    end Is_ISO_646;

    function Is_ISO_646 (Item : in String)    return Boolean is
    begin
        for Index in Item'Range loop
	    if Item( Index ) not in ISO_646 then
	        return FALSE;
	    end if;
	end loop;

	return TRUE;

    end Is_ISO_646;

    function To_ISO_646 (Item       : in Character;
                         Substitute : in ISO_646 := ' ')
      return ISO_646 is
    begin
	if Item not in ISO_646 then
	    return Substitute;
	end if;

	return Item;
    end To_ISO_646;

    function To_ISO_646 (Item       : in String;
                         Substitute : in ISO_646 := ' ')
      return String is
	Result : String( Item'Range );
    begin
	for Index in Item'Range loop
	    if Item( Index ) in ISO_646 then
		Result( Index ) := Item( Index );
	    else
		Result( Index ) := Substitute;
	    end if;
	end loop;

	return Result;
    end To_ISO_646;

--Classifications of and conversions between Wide_Character and Character.

    function Is_Character (Item : in Wide_Character) return Boolean is
    begin
        return Wide_Character'Pos(Item) <= Character'Pos(Character'Last);
    end Is_Character;

    function Is_String (Item : in Wide_String) return Boolean is
    begin
        for J in Item'Range loop
            if Wide_Character'Pos(Item (J)) > Character'Pos(Character'Last) then
                return False;
            end if;
        end loop;
        return True;
    end Is_String;

    function To_Character (Item       : in Wide_Character;
                           Substitute : in Character := ' ')
      return Character is
    begin
        if Is_Character (Item) then
            return Character'Val (Wide_Character'Pos (Item));
        else
            return Substitute;
        end if;
    end To_Character;

    function To_String    (Item       : in Wide_String;
                           Substitute : in Character := ' ')
      return String is

	Result : String( Item'Range );

    begin
        for J in Item'Range loop
            Result (J) := To_Character (Item (J), Substitute);
        end loop;
        return Result;
    end To_String;

    function To_Wide_Character (Item : in Character) return Wide_Character is

    begin
	return Wide_Character'Val( Character'Pos(Item) );
    end To_Wide_Character;

    function To_Wide_String    (Item : in String)    return Wide_String is

	Result : Wide_String( Item'Range );

    begin
	for Index in Item'Range loop
	    Result(Index) := Wide_Character'Val(Character'Pos(Item(Index)));
	end loop;

	return Result;
    end To_Wide_String;

end Ada.Characters.Handling;
