-- $Source: /home/dsd/d/aa/monoBANK/AA/j_ada.exceptions.bdy,v $
-- $Revision: 1.1 $ $Date: 96/08/15 14:34:07 $ $Author: jparadis $
--        Copyright (C) 1995 by Intermetrics, Inc.   

--RM5; 11.4.1
with java.lang.Throwable;
with java.lang.Class;
with java.lang.Object_Ops;
with java.lang.String;
with Interfaces.Java;
with Interfaces.Java.Ada_Exception;

pragma ada_child;
package body Ada.Exceptions is
    pragma Suppress( Elaboration_Check );

    function Exception_Name(Id : Exception_Id) return String is
    begin
	return Interfaces.Java.Java_to_Ada_String(
	  java.lang.Class.getName(java.lang.Class.Class_Ptr(Id)));
    end;

    procedure Raise_Exception(E : in Exception_Id; Message : in String := "")
    is 
	Exc : java.lang.Throwable.Throwable_Ptr;
	use Interfaces.Java.Ada_Exception;
    begin
	if E /= null then
	    -- Create an instance of specified Throwable class
	    Exc := java.lang.Throwable.Throwable_ptr(
	      java.lang.Class.newInstance(java.lang.Class.Class_Ptr(E)));

	    if Exc.all in Ada_Exception_Obj'Class then
		-- Set "settable" message
		Ada_Exception_Obj(Exc.all).settable_message :=
		  Interfaces.Java.Ada_To_Java_String(Message);
	    end if;
	    Interfaces.Java.Throw_Object(Exc);
	end if;
    end;

    function Exception_Message(X : Exception_Occurrence) return String is
	Exc : java.lang.Throwable.Throwable_Ptr :=
	  java.lang.Throwable.Throwable_Ptr(X);
	use Interfaces.Java.Ada_Exception;
	Msg : java.lang.String.String_Ptr := null;
	use type java.lang.String.String_Ptr;
    begin
	if Exc.all in Ada_Exception_Obj'Class then
	    -- Get "settable" message
	    Msg := Ada_Exception_Obj(Exc.all).settable_message;
	end if;

	if Msg = null then
	    -- Get builtin Java message
	    Msg := java.lang.Throwable.getMessage(Exc);
	end if;
	if Msg /= null then
	    return Interfaces.Java.Java_To_Ada_String(Msg);
	else
	    return "";
	end if;
    end Exception_Message;

    procedure Reraise_Occurrence(X : in Exception_Occurrence) is
    begin
	if X /= null then
	    Interfaces.Java.Throw_Object(
	      java.lang.Throwable.Throwable_ptr(X));
	end if;
    end Reraise_Occurrence;

    function Exception_Identity(X : Exception_Occurrence) return Exception_Id
    is begin
	return Exception_Id(java.lang.Object_Ops.getClass(
	  java.lang.Object_Ptr(X)));
    end;

    function Exception_Name(X : Exception_Occurrence) return String is
	-- Same as Exception_Name(Exception_Identity(X)).
    begin
	return Exception_Name(Exception_Identity(X));
    end;
    function Exception_Information(X : Exception_Occurrence) return String is
    begin
	return Exception_Name(Exception_Identity(X)) & ": " &
	  Exception_Message(X);
    end;

    procedure Save_Occurrence(Target : out Exception_Occurrence;
			      Source : in Exception_Occurrence) is
    begin
	Target := Source;
    end;
    function Save_Occurrence(Source : Exception_Occurrence)
			     return Exception_Occurrence_Access is
    begin
	return new Exception_Occurrence'(Source);
    end;

end Ada.Exceptions;
