-- $Source: /home/dsd/d/aa/monoBANK/AA/ada.storage_io.spc,v $
-- $Revision: 1.6 $ $Date: 96/07/18 17:01:37 $ $Author: stt $
--        Copyright (C) 1995 by Intermetrics, Inc.   

pragma Suppress( Elaboration_Check );

with Ada.IO_Exceptions;
with System.Storage_Elements;

pragma ada_child;
generic
    type Element_Type is private;

package Ada.Storage_IO is
    pragma Suppress( Elaboration_Check );

    pragma preelaborate( Storage_IO );

    Buffer_Size : constant System.Storage_Elements.Storage_Count := 
      Element_Type'Max_Size_In_Storage_Elements;

    subtype Buffer_Type is
    System.Storage_Elements.Storage_Array(1..Buffer_Size );


    procedure Read( Buffer : in Buffer_Type;
    		    Item   : out Element_Type );

    procedure Write( Buffer : out Buffer_Type;
    		     Item   : in Element_Type );

    Data_Error : exception renames IO_Exceptions.Data_Error;

    pragma Inline(Read, Write);


end Ada.Storage_IO;
