-- $Source: /home/dsd/d/aa/monoBANK/AA/java_awt_Event.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/26 17:24:54 $ $Author: vdelvecc $ 
with java.lang; use java.lang;
with java.lang.String; use java.lang.String;
package java.awt.Event is

    type Event_Obj;
    type Event_Ptr is access all Event_Obj'Class;

    type Event_Obj is new Object with record
        target : Object_Ptr;
        id : Integer;
        x : Integer;
        y : Integer;
        key : Integer;
        modifiers : Integer;
        clickCount : Integer;
        arg : Object_Ptr;
        evt : Event_Ptr;
    end record;

    SHIFT_MASK : constant Integer;
    pragma Import(Java, SHIFT_MASK);

    CTRL_MASK : constant Integer;
    pragma Import(Java, CTRL_MASK);

    META_MASK : constant Integer;
    pragma Import(Java, META_MASK);

    ALT_MASK : constant Integer;
    pragma Import(Java, ALT_MASK);

    HOME : constant Integer;
    pragma Import(Java, HOME);

    END_op : constant Integer;
    pragma Import(Java, END_op, "END");

    PGUP : constant Integer;
    pragma Import(Java, PGUP);

    PGDN : constant Integer;
    pragma Import(Java, PGDN);

    UP : constant Integer;
    pragma Import(Java, UP);

    DOWN : constant Integer;
    pragma Import(Java, DOWN);

    LEFT : constant Integer;
    pragma Import(Java, LEFT);

    RIGHT : constant Integer;
    pragma Import(Java, RIGHT);

    F1 : constant Integer;
    pragma Import(Java, F1);

    F2 : constant Integer;
    pragma Import(Java, F2);

    F3 : constant Integer;
    pragma Import(Java, F3);

    F4 : constant Integer;
    pragma Import(Java, F4);

    F5 : constant Integer;
    pragma Import(Java, F5);

    F6 : constant Integer;
    pragma Import(Java, F6);

    F7 : constant Integer;
    pragma Import(Java, F7);

    F8 : constant Integer;
    pragma Import(Java, F8);

    F9 : constant Integer;
    pragma Import(Java, F9);

    F10 : constant Integer;
    pragma Import(Java, F10);

    F11 : constant Integer;
    pragma Import(Java, F11);

    F12 : constant Integer;
    pragma Import(Java, F12);

    WINDOW_DESTROY : constant Integer;
    pragma Import(Java, WINDOW_DESTROY);

    WINDOW_EXPOSE : constant Integer;
    pragma Import(Java, WINDOW_EXPOSE);

    WINDOW_ICONIFY : constant Integer;
    pragma Import(Java, WINDOW_ICONIFY);

    WINDOW_DEICONIFY : constant Integer;
    pragma Import(Java, WINDOW_DEICONIFY);

    WINDOW_MOVED : constant Integer;
    pragma Import(Java, WINDOW_MOVED);

    KEY_PRESS : constant Integer;
    pragma Import(Java, KEY_PRESS);

    KEY_RELEASE : constant Integer;
    pragma Import(Java, KEY_RELEASE);

    KEY_ACTION : constant Integer;
    pragma Import(Java, KEY_ACTION);

    KEY_ACTION_RELEASE : constant Integer;
    pragma Import(Java, KEY_ACTION_RELEASE);

    MOUSE_DOWN : constant Integer;
    pragma Import(Java, MOUSE_DOWN);

    MOUSE_UP : constant Integer;
    pragma Import(Java, MOUSE_UP);

    MOUSE_MOVE : constant Integer;
    pragma Import(Java, MOUSE_MOVE);

    MOUSE_ENTER : constant Integer;
    pragma Import(Java, MOUSE_ENTER);

    MOUSE_EXIT : constant Integer;
    pragma Import(Java, MOUSE_EXIT);

    MOUSE_DRAG : constant Integer;
    pragma Import(Java, MOUSE_DRAG);

    SCROLL_LINE_UP : constant Integer;
    pragma Import(Java, SCROLL_LINE_UP);

    SCROLL_LINE_DOWN : constant Integer;
    pragma Import(Java, SCROLL_LINE_DOWN);

    SCROLL_PAGE_UP : constant Integer;
    pragma Import(Java, SCROLL_PAGE_UP);

    SCROLL_PAGE_DOWN : constant Integer;
    pragma Import(Java, SCROLL_PAGE_DOWN);

    SCROLL_ABSOLUTE : constant Integer;
    pragma Import(Java, SCROLL_ABSOLUTE);

    LIST_SELECT : constant Integer;
    pragma Import(Java, LIST_SELECT);

    LIST_DESELECT : constant Integer;
    pragma Import(Java, LIST_DESELECT);

    ACTION_EVENT : constant Integer;
    pragma Import(Java, ACTION_EVENT);

    LOAD_FILE : constant Integer;
    pragma Import(Java, LOAD_FILE);

    SAVE_FILE : constant Integer;
    pragma Import(Java, SAVE_FILE);

    GOT_FOCUS : constant Integer;
    pragma Import(Java, GOT_FOCUS);

    LOST_FOCUS : constant Integer;
    pragma Import(Java, LOST_FOCUS);

    function new_Event(
        target : Object_Ptr;
        when_op : Long_Integer;
        P3 : Integer;
        id : Integer;
        x : Integer;
        y : Integer;
        key : Integer;
        modifiers : Object_Ptr;
        Obj : Event_Ptr := null)
      return Event_Ptr;

    function new_Event(
        target : Object_Ptr;
        when_op : Long_Integer;
        P3 : Integer;
        id : Integer;
        x : Integer;
        y : Integer;
        key : Integer;
        Obj : Event_Ptr := null)
      return Event_Ptr;

    function new_Event(
        target : Object_Ptr;
        id : Integer;
        arg : Object_Ptr;
        Obj : Event_Ptr := null)
      return Event_Ptr;

    procedure translate(Obj : access Event_Obj;
        x : Integer;
        y : Integer);

    function shiftDown(Obj : access Event_Obj) return Boolean;

    function controlDown(Obj : access Event_Obj) return Boolean;

    function metaDown(Obj : access Event_Obj) return Boolean;

    function toString(Obj : access Event_Obj) return String_Ptr;

    pragma Import(Java, translate);
    pragma Import(Java, metaDown);
    pragma Import(Java, shiftDown);
    pragma Import(Java, controlDown);
    pragma Import(Java, toString);

    pragma Import(Java_Constructor, new_Event);

end java.awt.Event;
