-- $Source: /home/dsd/d/aa/monoBANK/AA/interfaces_java.spc,v $ 
-- $Revision: 1.1 $ $Date: 95/10/28 10:47:40 $ $Author: stt $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

-- ARM 5.0;B.2

package Interfaces is

    pragma Pure(Interfaces);
    pragma Suppress( Elaboration_Check );

    type Integer_64 is range -2**63 .. 2**63-1;  --2's complement

    type Integer_32 is range -2**31 .. 2**31-1;  --2's complement

    type Unsigned_64 is mod 2**64;

    type Unsigned_32 is mod 2**32;

    subtype Unsigned is Unsigned_32;

    function Shift_Left( Value : Unsigned_64; Amount : Natural )
      return Unsigned_64;

    function Shift_Right( Value : Unsigned_64; Amount : Natural )
      return Unsigned_64;

    function Shift_Right_Arithmetic( Value : Unsigned_64; Amount : Natural )
      return Unsigned_64;

    function Rotate_Left( Value : Unsigned_64; Amount : Natural ) 
      return Unsigned_64;

    function Rotate_Right( Value : Unsigned_64; Amount : Natural ) 
      return Unsigned_64;

    function Shift_Left( Value : Unsigned_32; Amount : Natural )
      return Unsigned_32;
    pragma Import( Intrinsic,
		   Shift_Left, 
		   Link_Name => "shift_left" );

    function Shift_Right( Value : Unsigned_32; Amount : Natural )
      return Unsigned_32;
    pragma Import( Intrinsic,
		   Shift_Right, 
		   Link_Name => "shift_right" );

    function Shift_Right_Arithmetic( Value : Unsigned_32; Amount : Natural )
      return Unsigned_32;
    pragma Import( Intrinsic,
		   Shift_Right_Arithmetic,
                   Link_Name => "shift_right_arithmetic" );

    function Rotate_Left( Value : Unsigned_32; Amount : Natural ) 
      return Unsigned_32;
    pragma Import( Intrinsic,
		   Rotate_Left,
                   Link_Name => "rotate_left" );

    function Rotate_Right( Value : Unsigned_32; Amount : Natural ) 
      return Unsigned_32;
    pragma Import( Intrinsic,
                   Rotate_Right,
                   Link_Name => "rotate_right" );

end Interfaces;
