-- $Source: /home/dsd/d/aa/monoBANK/AA/interfaces.java_java.spc,v $ 
-- $Revision: 1.14 $ $Date: 96/11/11 17:38:03 $ $Author: stt $ 

with java.lang;
with java.lang.String;
with java.lang.Throwable;
package Interfaces.Java is
    pragma Preelaborate;
    package java renames Standard.java;  
      -- so "java" refers to right thing below

    subtype Java_String is java.lang.String.String_Ptr;

  -- Conversion functions
    function Ada_To_Java_Wide_String(Str : Wide_String) return Java_String;
    pragma Import(Java, Ada_To_Java_Wide_String);
    function Ada_To_Java_String(Str : Standard.String) return Java_String;
    pragma Import(Java, Ada_To_Java_String);

    function Java_To_Ada_Wide_String(Str : Java_String) return Wide_String;
    pragma Import(Ada, Java_To_Ada_Wide_String, "Java_To_Ada_Wide_String");
    function Java_To_Ada_String(Str : Java_String) return Standard.String;
    pragma Import(Ada, Java_To_Ada_String, "Java_To_Ada_String");

  -- Conversion operator for string literals
    function "+"(Str : String) return Java_String;
    pragma Import(Java, "+", "Ada_To_Java_String");

    -- Throw a "throwable" object
    procedure Throw_Object(Obj : java.lang.Throwable.Throwable_Ptr);
    pragma Import(Java, Throw_Object);

    --
    -- Basic types for aliased objects and the like.
    --

    type Access_Obj is limited record
       value : java.lang.Object_Ptr;
    end record;

    type Two_Word_Access_Obj is limited record
       word1 : java.lang.Object_Ptr;
       word2 : java.lang.Object_Ptr;
    end record;

    type Integer_Obj is limited record
       value : Standard.Integer;
    end record;

    type Long_Obj is limited record
       value : Long_Integer;
    end record;

    type Float_Obj is limited record
       value : Standard.Float;
    end record;

    type Double_Obj is limited record
       value : Long_Float;
    end record;

end Interfaces.Java;

