-- $Source: /home/dsd/d/aa/monoBANK/AA/interfaces.java.ada_applet.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/14 21:37:25 $ $Author: vdelvecc $ 
with java.applet.Applet; use java.applet.Applet;
with java.lang.Runnable; use java.lang.Runnable;
with java.lang.Thread; use java.lang.Thread;
with java.awt.Graphics; use java.awt.Graphics;
package interfaces.java.Ada_Applet is
    type Ada_Applet_Obj is abstract new Applet_Obj with record
	Runnable : aliased Runnable_Obj;  -- implements Runnable
	thread : Thread_Ptr;
    end record;

    procedure run(this : access Ada_Applet_Obj) is abstract;
      -- Will call main subprogram

    procedure start(this : access Ada_Applet_Obj);
    procedure stop(this : access Ada_Applet_Obj);

    pragma Convention(Java, run);
      -- So it matches "run" in Runnable interface
end interfaces.java.Ada_Applet;

with java.awt.Color; use java.awt.Color;
with java.lang.System; use java.lang.System;
with java.io.PrintStream; use java.io.PrintStream;
package body interfaces.java.Ada_Applet is

    procedure start(this : access Ada_Applet_Obj) is
    begin
	if this.thread = null or else not isAlive(this.thread) then
	    -- (Re)create the thread
	    this.thread := new_Thread(
	      this.Runnable'Access, +"Ada main thread");
	    start(this.thread);
	end if;
    end start;

    procedure stop(this : access Ada_Applet_Obj) is
    begin
	if this.thread /= null then
	    if isAlive(this.thread) then
		stop(this.thread);
	    end if;
	    this.thread := null;
	end if;
    end stop;

end interfaces.java.Ada_Applet;
