-- $Source: /home/dsd/d/aa/monoBANK/AA/interfaces.java.nonlimited.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/14 21:50:30 $ $Author: vdelvecc $ 

package interfaces.java.NonLimited is

  -- The mother of all non-limited Ada record types:

    type NonLimited_Obj is tagged limited null record;
    type NonLimited_Ptr is access all NonLimited_Obj'Class;

  -- This operation is used for assignment and initialization
    function Directed_Copy(From : NonLimited_Obj; Target : NonLimited_Ptr)
      return NonLimited_Ptr;
        -- If Target is null, or not in <this_type>'Class, a new object is 
        --   allocated and then "From" is copied into it;
        -- If Target is non-null and in <this_type>'Class, this copies "From"
        -- into "Target".
        -- In any case, a pointer to the copy is returned.

  -- Directed_Array_Copy will be defined later, and perhaps elsewhere; 
  -- it will probably need to be implemented in Java, given our problematic
  -- support for access-to-unconstrained arrays.
end interfaces.java.NonLimited;

package body interfaces.java.NonLimited is
    function Directed_Copy(From : NonLimited_Obj; Target : NonLimited_Ptr)
      return NonLimited_Ptr is
	Result : NonLimited_Ptr;
	  -- Would be Descendant_Ptr in overridings
    begin
	if Target = null then 
	    -- NOTE: for overridigns, should add:
	    --     or else Target.all not in Descendant'Class then
	    Result := new NonLimited_Obj;
	else
	    Result := Target;
		-- Would be Descendant_Ptr(Target) in overridings
	end if;

	-- Directed-Copy components (there aren't any in this case)
	return NonLimited_Ptr(Result);
    end Directed_Copy;
	    
end interfaces.java.NonLimited;
