-- $Source: /home/dsd/d/aa/monoBANK/AA/java_lang_SecurityManager.ada,v $ 
-- $Revision: 1.1 $ $Date: 96/08/26 17:28:57 $ $Author: vdelvecc $ 
with java.lang; use java.lang;
with java.lang.Thread; use java.lang.Thread;
with java.lang.String; use java.lang.String;
with java.lang.ThreadGroup; use java.lang.ThreadGroup;
with java.io.FileDescriptor; use java.io.FileDescriptor;
package java.lang.SecurityManager is

    type SecurityManager_Obj is abstract new Object with null record;
    type SecurityManager_Ptr is access all SecurityManager_Obj'Class;

    function getInCheck(Obj : access SecurityManager_Obj) return Boolean;

    function getSecurityContext(Obj : access SecurityManager_Obj) return Object_Ptr;

    procedure checkCreateClassLoader(Obj : access SecurityManager_Obj);

    procedure checkAccess(Obj : access SecurityManager_Obj;
        g : Thread_Ptr);

    procedure checkAccess(Obj : access SecurityManager_Obj;
        g : ThreadGroup_Ptr);

    procedure checkExit(Obj : access SecurityManager_Obj;
        status : Integer);

    procedure checkExec(Obj : access SecurityManager_Obj;
        cmd : String_Ptr);

    procedure checkLink(Obj : access SecurityManager_Obj;
        lib : String_Ptr);

    procedure checkRead(Obj : access SecurityManager_Obj;
        fd : FileDescriptor_Ptr);

    procedure checkRead(Obj : access SecurityManager_Obj;
        file : String_Ptr);

    procedure checkRead(Obj : access SecurityManager_Obj;
        file : String_Ptr;
        context : Object_Ptr);

    procedure checkWrite(Obj : access SecurityManager_Obj;
        fd : FileDescriptor_Ptr);

    procedure checkWrite(Obj : access SecurityManager_Obj;
        file : String_Ptr);

    procedure checkDelete(Obj : access SecurityManager_Obj;
        file : String_Ptr);

    procedure checkConnect(Obj : access SecurityManager_Obj;
        host : String_Ptr;
        port : Integer);

    procedure checkConnect(Obj : access SecurityManager_Obj;
        host : String_Ptr;
        port : Integer;
        context : Object_Ptr);

    procedure checkListen(Obj : access SecurityManager_Obj;
        port : Integer);

    procedure checkAccept(Obj : access SecurityManager_Obj;
        host : String_Ptr;
        port : Integer);

    procedure checkPropertiesAccess(Obj : access SecurityManager_Obj);

    procedure checkPropertyAccess(Obj : access SecurityManager_Obj;
        key : String_Ptr);

    procedure checkPropertyAccess(Obj : access SecurityManager_Obj;
        key : String_Ptr;
        def : String_Ptr);

    function checkTopLevelWindow(Obj : access SecurityManager_Obj;
        window : Object_Ptr)
      return Boolean;

    procedure checkPackageAccess(Obj : access SecurityManager_Obj;
        pkg : String_Ptr);

    procedure checkPackageDefinition(Obj : access SecurityManager_Obj;
        pkg : String_Ptr);

    procedure checkSetFactory(Obj : access SecurityManager_Obj);

    pragma Import(Java, checkTopLevelWindow);
    pragma Import(Java, checkConnect);
    pragma Import(Java, checkExec);
    pragma Import(Java, getSecurityContext);
    pragma Import(Java, checkPackageDefinition);
    pragma Import(Java, checkRead);
    pragma Import(Java, checkLink);
    pragma Import(Java, checkWrite);
    pragma Import(Java, checkDelete);
    pragma Import(Java, checkExit);
    pragma Import(Java, checkAccept);
    pragma Import(Java, checkAccess);
    pragma Import(Java, checkCreateClassLoader);
    pragma Import(Java, checkPropertiesAccess);
    pragma Import(Java, checkPropertyAccess);
    pragma Import(Java, checkSetFactory);
    pragma Import(Java, getInCheck);
    pragma Import(Java, checkListen);
    pragma Import(Java, checkPackageAccess);


end java.lang.SecurityManager;
