-- $Source: /home/dsd/d/aa/monoBANK/AA/system.storage_elements.spc,v $
-- $Revision: 1.6 $ $Date: 96/04/26 11:25:16 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.Storage_Elements is

    pragma Preelaborate( System.Storage_Elements );

    pragma Suppress( Elaboration_Check );

    type Storage_Offset is range Min_Int .. Max_Int;

    subtype Storage_Count is Storage_Offset range 0..Storage_Offset'Last;

    -- Should be unsigned
    type Storage_Element is mod 2 ** Storage_Unit;

    for Storage_Element'Size use Storage_Unit;
    type Storage_Array is array 
      (Storage_Offset range <>) of aliased Storage_Element;
    for Storage_Array'Component_Size use Storage_Unit;

    -- Address arithemetic 

    function "+"( Left  : Address; 
    	    	  Right : Storage_Offset) return Address;
    function "+"( Left  : Storage_Offset; 
       	    	  Right : Address) return Address;

    function "-"( Left  : Address; 
    	    	  Right : Storage_Offset) return Address;
    function "-"( Left  : Address; 
    	    	  Right : Address) return Storage_Offset;

    function "mod"( Left  : Address; 
    	    	    Right : Storage_Offset ) return Storage_Offset;
    pragma Export ( Ada, "mod", "storage_elements_mod" );
    pragma Global( "mod" );
    
    type Integer_Address is new Integer;
    function To_Address( Value : Integer_Address ) return Address;
    function To_Integer( Value : Address ) return Integer_Address;

private

    pragma Import ( Intrinsic,
                    "+",
                    "*e_system_storage_elements.+" );
    pragma Import ( Intrinsic,
                    "-",
                    "*e_system_storage_elements.-" );
    	
end System.Storage_Elements;
