-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.string_utilities.spc,v $
-- $Revision: 1.2 $ $Date: 95/10/10 13:46:20 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.RTS.String_Utilities is

    pragma Suppress( Elaboration_Check );

    --| Overview
    --|
    --| String utilities shared by different packages in the RTS

    function Upper_Case (C : in character) return character;

    --| Effect
    --|
    --| If character C is a lower case alphabetic character, return
    --| the upper case equivalent. Otherwise, return C
    --| unchanged.
    --| (Upper_Case('a') -> 'A', Upper_Case('1') -> '1'), etc.)

    function Upper_Case (S : in string) return string;

    --| Effect
    --|
    --| Convert all lower case alphabetic characters in string S
    --| to upper case, and leave all other characters
    --| unchanged.

    function Lower_Case (C : in character) return character;

    --| Effect
    --|
    --| If C is a lower case, alphabetic character, return the
    --| upper case equivalent. Otherwise, just return C.

    function Lower_Case (S : in string) return string;

    --| Effect
    --|
    --| Convert all upper case alphabetic characters in string S
    --| to lower case, and leave all other characters
    --| unchanged.

end System.RTS.String_Utilities;
