-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.fixed_image_and_value_pkg.bdy,v $
-- $Revision: 1.5 $ $Date: 95/11/29 13:26:39 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.Float_IO_Support;
with Ada.Characters.Handling;

package body System.RTS.Fixed_Image_And_Value_Pkg is

    pragma Suppress( Elaboration_Check );

    package FIO renames System.RTS.Float_IO_Support;

    type U_Str is array( integer range <> ) of Character;

    function RTS_Fixed_Image( The_Fixed  : TGT.Longest_Float;
      	    	    	      Num_Digits : Integer ) return String is
        Result : constant String :=
	    	    FIO.Float_Image( ITEM => The_Fixed,
	    	    	    	     FORE => 1,
				     AFT  => Num_Digits,
				     EXP  => 0 );
    begin
        if Result(Result'first) = '-' then
	    return Result;
	else
	    return ' ' & Result;
	end if;
    end RTS_Fixed_Image;


    function RTS_Fixed_Wide_Image( The_Fixed  : TGT.Longest_Float;
                                   Num_Digits : Integer ) return Wide_String is
        Result : constant String :=
	    	    FIO.Float_Image( ITEM => The_Fixed,
	    	    	    	     FORE => 1,
				     AFT  => Num_Digits,
				     EXP  => 0 );
    begin
        if Result(Result'first) = '-' then
            return Ada.Characters.Handling.To_Wide_String( Result );
	else
            return Ada.Characters.Handling.To_Wide_String( ' ' & Result );
	end if;
    end RTS_Fixed_Wide_Image;

    function RTS_Fixed_Value( The_Image : String ) return TGT.Longest_Float is
    begin
    	return FIO.Float_Value( The_Image );
    end RTS_Fixed_Value;

    function RTS_Fixed_Wide_Value( The_Image : Wide_String ) 
       return TGT.Longest_Float is
    begin
   	return FIO.Float_Value( Ada.Characters.Handling.To_String(The_Image) );
    end RTS_Fixed_Wide_Value;

end System.RTS.Fixed_Image_And_Value_Pkg;
