-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.fixed_image_and_value_pkg.spc,v $ 
-- $Revision: 1.4 $ $Date: 96/04/26 11:04:08 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.TGT;

package System.RTS.Fixed_Image_And_Value_Pkg is

    pragma Suppress( Elaboration_Check );

    package TGT renames System.RTS.TGT;
    
    function RTS_Fixed_Image ( The_Fixed  : TGT.Longest_Float;
      	    	    	       Num_Digits : Integer ) return String;
    pragma export (Ada,
                   RTS_Fixed_Image,
                   "rts_fixed_image");
    pragma global (RTS_Fixed_Image);
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('IMAGE) of a fixed type.
    --| Digits designates how many digits should be in the output.
    --+-------------------------------------------------------

    function RTS_Fixed_Wide_Image ( The_Fixed  : TGT.Longest_Float;
      	    	    	            Num_Digits : Integer ) return Wide_String;
    pragma export (Ada,
                   RTS_Fixed_Wide_Image,
                   "rts_fixed_wide_image");
    pragma global (RTS_Fixed_Wide_Image);
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Returns the image attribute ('WIDE_IMAGE) of a fixed type.
    --| Digits designates how many digits should be in the output.
    --+-------------------------------------------------------

    function RTS_Fixed_Value ( The_Image : String ) return TGT.Longest_Float;
    pragma export (Ada,
                   RTS_Fixed_Value,
                   "rts_fixed_value");
    pragma global (RTS_Fixed_Value);
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing a fixed, returns the value of
    --| the corresponding fixed type ('VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| fixed literal.
    --+-------------------------------------------------------

    function RTS_Fixed_Wide_Value( The_Image : Wide_String ) 
       return TGT.Longest_Float;
    pragma export (Ada,
                   RTS_Fixed_Wide_Value,
                   "rts_fixed_wide_value");
    pragma global (RTS_Fixed_Wide_Value);
    --+-------------------------------------------------------
    --| EFFECTS
    --|
    --| Given a string representing a fixed, returns the value of
    --| the corresponding fixed type ('WIDE_VALUE). Raises
    --| CONSTRAINT_ERROR if the string is not a syntactically legal
    --| fixed literal.
    --+-------------------------------------------------------

end System.RTS.Fixed_Image_And_Value_Pkg;
