-- $Source: /home/dsd/d/aa/monoBANK/AA/java_awt_Toolkit.ada,v $ 
-- $Revision: 1.2 $ $Date: 96/10/31 16:04:19 $ $Author: stt $ 
with java.lang; use java.lang;
with java.awt.FontMetrics; use java.awt.FontMetrics;
with java.awt.Font; use java.awt.Font;
with java.lang.String; use java.lang.String;
with java.awt.Image; use java.awt.Image;
    use java.awt.image.ColorModel;
    use java.awt.image.ImageProducer;
    use java.awt.image.ImageObserver;
with java.awt.Dimension; use java.awt.Dimension;
with java.net.URL; use java.net.URL;
with java.awt.Component; use java.awt.Component;
package java.awt.Toolkit is

    type Toolkit_Obj is abstract new Object with null record;
    type Toolkit_Ptr is access all Toolkit_Obj'Class;

    function getScreenSize(Obj : access Toolkit_Obj) return Dimension_Ptr is abstract;

    function getScreenResolution(Obj : access Toolkit_Obj) return Integer is abstract;

    function getColorModel(Obj : access Toolkit_Obj) return ColorModel_Ptr is abstract;

    function getFontList(Obj : access Toolkit_Obj) return String_Array is abstract;

    function getFontMetrics(Obj : access Toolkit_Obj;
        P1 : Font_Ptr)
      return FontMetrics_Ptr is abstract;

    procedure sync(Obj : access Toolkit_Obj) is abstract;

    function getDefaultToolkit return Toolkit_Ptr;

    function getImage(Obj : access Toolkit_Obj;
        P1 : String_Ptr)
      return Image_Ptr is abstract;

    function getImage(Obj : access Toolkit_Obj;
        P1 : URL_Ptr)
      return Image_Ptr is abstract;

    function prepareImage(Obj : access Toolkit_Obj;
        P1 : Image_Ptr;
        P2 : Integer;
        P3 : Integer;
        P4 : ImageObserver_Ptr)
      return Boolean is abstract;

    function checkImage(Obj : access Toolkit_Obj;
        P1 : Image_Ptr;
        P2 : Integer;
        P3 : Integer;
        P4 : ImageObserver_Ptr)
      return Integer is abstract;

    function createImage(Obj : access Toolkit_Obj;
        P1 : ImageProducer_Ptr)
      return Image_Ptr is abstract;


    -- This operation was moved here from "Component" to avoid circularity
    function getToolkit(Obj : access Component_Obj'Class) return Toolkit_Ptr;

    pragma Import(Java, getImage);
    pragma Import(Java, getScreenSize);
    pragma Import(Java, checkImage);
    pragma Import(Java, getFontMetrics);
    pragma Import(Java, getDefaultToolkit);
    pragma Import(Java, getScreenResolution);
    pragma Import(Java, createImage);
    pragma Import(Java, getColorModel);
    pragma Import(Java, prepareImage);
    pragma Import(Java, sync);
    pragma Import(Java, getFontList);


    pragma Import(Java, getToolkit, "java/awt/Component.getToolkit");

end java.awt.Toolkit;
