-- $Source: /home/dsd/d/aa/monoBANK/AA/java_util_Vector.ada,v $ 
-- $Revision: 1.2 $ $Date: 96/10/31 16:14:39 $ $Author: stt $ 
with java.lang; use java.lang;
with java.lang.String; use java.lang.String;
with java.util.Enumeration; use java.util.Enumeration;
with java.lang.Cloneable; use java.lang.Cloneable;
package java.util.Vector is

    type Vector_Obj is new Object with record
        Cloneable : aliased Cloneable_Obj;  -- implements Cloneable
    end record;
    type Vector_Ptr is access all Vector_Obj'Class;

    function new_Vector(
        initialCapacity : Integer;
        capacityIncrement : Integer;
        Obj : Vector_Ptr := null)
      return Vector_Ptr;

    function new_Vector(
        initialCapacity : Integer;
        Obj : Vector_Ptr := null)
      return Vector_Ptr;

    function new_Vector(Obj : Vector_Ptr := null) return Vector_Ptr;

    type Object_Array is array(Positive range <>) of Object_Ptr;

    procedure copyInto(Obj : access Vector_Obj;
        anArray : Object_Array);

    procedure trimToSize(Obj : access Vector_Obj);

    procedure ensureCapacity(Obj : access Vector_Obj;
        minCapacity : Integer);

    procedure setSize(Obj : access Vector_Obj;
        newSize : Integer);

    function capacity(Obj : access Vector_Obj) return Integer;

    function size(Obj : access Vector_Obj) return Integer;

    function isEmpty(Obj : access Vector_Obj) return Boolean;

    function elements(Obj : access Vector_Obj) return Enumeration_Ptr;

    function contains(vector : access Vector_Obj;
        elem : Object_Ptr)
      return Boolean;

    function indexOf(vector : access Vector_Obj;
        elem : Object_Ptr)
      return Integer;

    function indexOf(vector : access Vector_Obj;
        elem : Object_Ptr;
        index : Integer)
      return Integer;

    function lastIndexOf(vector : access Vector_Obj;
        elem : Object_Ptr)
      return Integer;

    function lastIndexOf(vector : access Vector_Obj;
        elem : Object_Ptr;
        index : Integer)
      return Integer;

    function elementAt(vector : access Vector_Obj;
        index : Integer)
      return Object_Ptr;

    function firstElement(Obj : access Vector_Obj) return Object_Ptr;

    function lastElement(Obj : access Vector_Obj) return Object_Ptr;

    procedure setElementAt(vector : access Vector_Obj;
        obj : Object_Ptr;
        index : Integer);

    procedure removeElementAt(vector : access Vector_Obj;
        index : Integer);

    procedure insertElementAt(vector : access Vector_Obj;
        obj : Object_Ptr;
        index : Integer);

    procedure addElement(vector : access Vector_Obj;
        obj : Object_Ptr);

    function removeElement(vector : access Vector_Obj;
        obj : Object_Ptr)
      return Boolean;

    procedure removeAllElements(Obj : access Vector_Obj);

    function clone(Obj : access Vector_Obj) return Object_Ptr;

    function toString(Obj : access Vector_Obj) return String_Ptr;

    pragma Import(Java, indexOf);
    pragma Import(Java, removeElement);
    pragma Import(Java, setSize);
    pragma Import(Java, contains);
    pragma Import(Java, clone);
    pragma Import(Java, lastElement);
    pragma Import(Java, elements);
    pragma Import(Java, addElement);
    pragma Import(Java, size);
    pragma Import(Java, trimToSize);
    pragma Import(Java, lastIndexOf);
    pragma Import(Java, removeElementAt);
    pragma Import(Java, insertElementAt);
    pragma Import(Java, ensureCapacity);
    pragma Import(Java, capacity);
    pragma Import(Java, elementAt);
    pragma Import(Java, removeAllElements);
    pragma Import(Java, firstElement);
    pragma Import(Java, setElementAt);
    pragma Import(Java, isEmpty);
    pragma Import(Java, copyInto);
    pragma Import(Java, toString);

    pragma Import(Java_Constructor, new_Vector);

end java.util.Vector;
