
-- This is the data structure created by the builder containing
-- options for the runtime.

-- This structure must match what is defined in buildopts.h

package System.RTS.Init_Pkg.NT.BuildOpts is

  type Option_Record is
     record
        stack_size     : integer;	-- default task stack size
        sec_stack_size : integer;	-- initial secondary stack size
        spare0         : integer;	-- initial heap size
        spare1         : integer;	-- heap increment size
        flags          : integer;	-- flags, currently unused
        timeslice      : integer;
        spare2         : integer;
        spare3         : integer;
        spare4         : integer;
        spare5         : integer;
     end record;

  type Option_Record_Access is access all Option_Record;

  function AdaBuildOpts return Option_Record_Access;
  pragma Import (C, AdaBuildOpts, "ada_opts");

end System.RTS.Init_Pkg.NT.BuildOpts;
