-- $Source: /home/dsd/d/aa/monoBANK/AA/ada.exceptions.spc,v $
-- $Revision: 1.2 $ $Date: 95/10/10 13:14:06 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

--RM5; 11.4.1

with System.RTS.Exception_Types;

pragma ada_child;
package Ada.Exceptions is
    pragma Suppress( Elaboration_Check );

    type Exception_Id is private;

    Null_Id : constant Exception_Id;

    function Exception_Name(Id : Exception_Id) return String;

    type Exception_Occurrence is limited private;

    type Exception_Occurrence_Access is access all Exception_Occurrence;

    Null_Occurrence: constant Exception_Occurrence;

    procedure Raise_Exception(E : in Exception_Id; Message : in String := "");
    function Exception_Message(X : Exception_Occurrence) return String;
    procedure Reraise_Occurrence(X : in Exception_Occurrence);

    function Exception_Identity(X : Exception_Occurrence) return Exception_Id;
    function Exception_Name(X : Exception_Occurrence) return String;
	-- Same as Exception_Name(Exception_Identity(X)).
    function Exception_Information(X : Exception_Occurrence) return String;

    procedure Save_Occurrence(Target : out Exception_Occurrence;
			      Source : in Exception_Occurrence);
    function Save_Occurrence(Source : Exception_Occurrence)
			     return Exception_Occurrence_Access;

private

    package ET renames System.RTS.Exception_Types;

    type Exception_Id is new ET.Exception_Id;
    Null_Id : constant Exception_Id := Exception_Id(ET.Null_Id);

    package AEO is new ET.Generic_Occurrence(200);

    type Exception_Occurrence is new AEO.Exception_Occurrence;
    Blank_Occurrence : Exception_Occurrence;

    Null_Occurrence : constant Exception_Occurrence := Blank_Occurrence;

    
end Ada.Exceptions;
