-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.heap_storage_pkg.spc,v $ 
-- $Revision: 1.9 $ $Date: 1996/11/27 21:56:01 $ $Author: stt $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.Storage_Elements;

package System.RTS.Heap_Storage_Pkg is

    pragma Suppress( Elaboration_Check );

    package SSE renames System.Storage_Elements;

    function RTS_Allocate (
      Size_In_Storage_Elements : in SSE.Storage_Count
    ) return Address;
    pragma Export (ada, RTS_Allocate, "rts_allocate" );
    pragma Global (RTS_Allocate);

    --* OVERVIEW
    -- this function uses the quick-fit algorithm.  It should be called when
    -- allocating from the default heap.
     
    procedure RTS_Deallocate (
      Storage_Address : in Address
    );
    pragma Export (ada, RTS_Deallocate, "rts_deallocate" );
    pragma Global (RTS_Deallocate);

    --* OVERVIEW
    -- this function assumes deallocation from the default heap


    procedure RTS_Heap_Init( Location : Address;
                             Size     : Integer );
    pragma Export (ada,
		   RTS_Heap_Init,
                   "rts_heap_init" );
    --*IMPLEMENTATION
    -- initialize the heap
	
end System.RTS.Heap_Storage_Pkg;
