-- "This unpublished work is protected both as a proprietary work and
-- under the Universal Copyright Convention and the US Copyright Act of
-- 1976. Its distribution and access are limited only to authorized
-- persons. Copr. (c) Alsys. Created 1990, initially licensed 1990.
-- All rights reserved.

-- Unauthorized  use (including use to prepare other works), disclosure,
-- reproduction, or distribution may violate national criminal law."

------------------------------------------------------------------------------
-- This module defines the interface for the intrinsic routines used to     --
-- generate machine language in the context of 386 Ada source programs.     --
------------------------------------------------------------------------------

package body MACHINE_OPERATIONS_386 is

   -- Bodies for generic functions
   -- These bodies are never executed, but they must be compiled to
   -- complete the closure for any program using them.

   -- All the bodies are recursive to prevent inlining of calls.

   function PTR_TEMPLATE (OBJECT : T; LENGTH : NATURAL := 0) return MEM is
   begin
      return PTR_TEMPLATE(OBJECT);
   end PTR_TEMPLATE;

   function BYTE_PTR_TEMPLATE (OBJECT : T;
                               SIZE   : SIZE_TYPE := -1) return MEM is
   begin
      return BYTE_PTR_TEMPLATE(OBJECT);
   end BYTE_PTR_TEMPLATE;

   function WORD_PTR_TEMPLATE (OBJECT : T;
                               SIZE   : SIZE_TYPE := -2) return MEM is
   begin
      return WORD_PTR_TEMPLATE(OBJECT);
   end WORD_PTR_TEMPLATE;

   function DWORD_PTR_TEMPLATE (OBJECT : T;
                                SIZE   : SIZE_TYPE := -4) return MEM is
   begin
      return DWORD_PTR_TEMPLATE(OBJECT);
   end DWORD_PTR_TEMPLATE;

   function FWORD_PTR_TEMPLATE (OBJECT : T;
                                SIZE   : SIZE_TYPE := -6) return MEM is
   begin
      return FWORD_PTR_TEMPLATE(OBJECT);
   end FWORD_PTR_TEMPLATE;

   function QWORD_PTR_TEMPLATE (OBJECT : T;
                                SIZE   : SIZE_TYPE := -8) return MEM is
   begin
      return QWORD_PTR_TEMPLATE(OBJECT);
   end QWORD_PTR_TEMPLATE;

   function TWORD_PTR_TEMPLATE (OBJECT : T;
                                SIZE   : SIZE_TYPE := -10) return MEM is
   begin
      return TWORD_PTR_TEMPLATE(OBJECT);
   end TWORD_PTR_TEMPLATE;


   function OFFSET_TEMPLATE (OBJECT : T;
                             MARKER : SIZE_TYPE := -1) return OFS is
   begin
      return OFFSET_TEMPLATE(OBJECT);
   end OFFSET_TEMPLATE;

end MACHINE_OPERATIONS_386; 
-- VAX/DEC CMS REPLACEMENT HISTORY, Element M386R.ADB
-- *3     4-MAR-1992 18:07:36 KEHS "REMOVE OBJECTS OF GENERIC PARAMETER TYPES"
-- *2    14-FEB-1992 11:16:35 KEHS "MAKE GENERIC FUNCTIONS RECURSIVE SO THEY WILL NEVER BE INLINED"
-- *1    30-JAN-1992 10:34:23 KEHS "DUMMY BODIES FOR GENERIC FUNCTIONS"
-- VAX/DEC CMS REPLACEMENT HISTORY, Element M386R.ADB
