-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.modular_operations_pkg.spc,v $
-- $Revision: 1.4 $ $Date: 96/07/31 16:42:42 $ $Author: akira $
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.Unsigned;

package System.RTS.Modular_Operations_Pkg is
pragma Suppress( Elaboration_Check );

    subtype Unsigned is System.RTS.Unsigned.Unsigned_Integer;

    -- The division/remainder/modulus procedures do not use the
    -- normal interface.  They are closely tied to the back-end
    -- code generation.  The interface is that the Left and
    -- Right inputs are in a single AQ register pair.  The
    -- quotient and remainder/modulus are returned in the same
    -- pair.

    procedure RTS_Unsigned_REMQUO_1(
      Left  : in out Unsigned;
      Right : in out Unsigned );
    pragma Export( Ada,
                   RTS_Unsigned_REMQUO_1,
                   "rts_unsigned_remquo_1" );

    procedure RTS_Unsigned_REMQUO_2(
      Left  : in out Unsigned;
      Right : in out Unsigned );
    pragma Export( Ada,
                   RTS_Unsigned_REMQUO_2,
                   "rts_unsigned_remquo_2" );

    function RTS_Modular_Mult(
      Modulus : in Unsigned;
      Left    : in Unsigned;
      Right   : in Unsigned ) return Unsigned;
    pragma Export( Ada,
                   RTS_Modular_Mult,
                   "rts_modular_mult" );

    function RTS_Modular_Power(
      Modulus : in Unsigned;
      Left    : in Unsigned;
      Right   : in Unsigned ) return Unsigned;
    pragma Export( Ada,
                   RTS_Modular_Power,
                   "rts_modular_power" );

end System.RTS.Modular_Operations_Pkg;
