-- $Source: /home/dsd/d/aa/monoBANK/AA/TSP_system.bdy,v $ 
-- $Revision: 1.2 $ $Date: 96/04/19 11:51:52 $ $Author: akira $ 
with Unchecked_Conversion;

package body System is

   pragma SUPPRESS (ELABORATION_CHECK);
   pragma SUPPRESS (STORAGE_CHECK);

    function FETCH_FROM_ADDRESS (A : in ADDRESS) return TARGET is
       type TA is access TARGET;
       function CONV is new UNCHECKED_CONVERSION (ADDRESS,TA);
    begin
       return CONV(A).all;
    end FETCH_FROM_ADDRESS;
    
    procedure ASSIGN_TO_ADDRESS (A : in ADDRESS; T : in TARGET) is
       type TA is access TARGET;
       function CONV is new UNCHECKED_CONVERSION (ADDRESS,TA);
    begin
       CONV(A).all:=T;
    end ASSIGN_TO_ADDRESS;
 
    procedure MOVE (TO     : in ADDRESS;
                    FROM   : in ADDRESS;
                    LENGTH : in OBJECT_LENGTH) is
       type T is new STRING(1..NATURAL(LENGTH));
       type TA is access T;
       function CONV is new UNCHECKED_CONVERSION (ADDRESS,TA);       
    begin
       CONV(TO).all:=CONV(FROM).all;
    end MOVE;
    
    type UNSIGNED is mod 2**32;

    function CONV is new UNCHECKED_CONVERSION (ADDRESS,UNSIGNED);
    function CONV is new UNCHECKED_CONVERSION (UNSIGNED,ADDRESS);
 
    function "mod" (LEFT : in ADDRESS; RIGHT : in POSITIVE) return NATURAL is
    begin
       return NATURAL (CONV(LEFT) mod UNSIGNED(RIGHT));
    end "mod";
 
    -- Returns the given address rounded to a specific value.
    function ROUND (VALUE     : in ADDRESS;
		    DIRECTION : in ROUND_DIRECTION;
		    MODULUS   : in POSITIVE) return ADDRESS is
    begin
       if DIRECTION=UP then
          return VALUE + MODULUS - OFFSET (VALUE mod MODULUS);
       else
          return VALUE - OFFSET (VALUE mod MODULUS);
       end if;
    end ROUND;
 
    function IMAGE ( LEFT : in ADDRESS ) return ADDRESS_STRING is
       S:ADDRESS_STRING;
       A:UNSIGNED:=CONV(LEFT);
       C:UNSIGNED;
    begin
       for I in reverse S'RANGE loop
          C:=A mod 16;
          if C>=10 then
             C:=C+(CHARACTER'POS('A')-CHARACTER'POS('0')-10);
          end if;
          S(I):=CHARACTER'VAL(C+CHARACTER'POS('0'));
	  A:=A/16;
       end loop;
       return S;
    end;
    
    function VALUE ( LEFT : in STRING ) return ADDRESS is
       A:UNSIGNED:=0;
       C:CHARACTER;
       FIRST:NATURAL:=LEFT'FIRST;
       LAST :NATURAL:=LEFT'LAST;
    begin
       while FIRST<=LEFT'LAST and then LEFT(FIRST)=' ' loop
          FIRST:=FIRST+1;
       end loop; 
       while LAST>=LEFT'FIRST and then LEFT(LAST)=' ' loop
          LAST:=LAST-1;
       end loop;
       if FIRST>LAST then
          raise CONSTRAINT_ERROR;
       end if; 
       while FIRST<=LAST loop
          if A>=16#10000000# then
             raise CONSTRAINT_ERROR;
          end if;
          A:=A*16;
          C:=LEFT(FIRST);
          case C is
             when '0'..'9' =>
                A:=A+CHARACTER'POS(C)-CHARACTER'POS('0');
             when 'a'..'f' =>
                A:=A+CHARACTER'POS(C)-CHARACTER'POS('a')+10;
             when 'A'..'F' =>
                A:=A+CHARACTER'POS(C)-CHARACTER'POS('A')+10;
             when others =>
                raise CONSTRAINT_ERROR;
          end case;
          FIRST:=FIRST+1;
       end loop; 
       return CONV(A);
    end;

end System;
