with System;
with System.RTS.Win32;
package system.rts.temp_io is

    -- Acts on traces:
    --    76 : Critical section entered by each output function
    --         New_line and Put_line exit the section.  This ensures
    --         each line of output corresponds to a single task's output
    --    79 : Each line out output prefixed by current task id.

    pragma Suppress( Elaboration_Check );
    pragma preelaborate( system.rts.temp_io );

    subtype Count is Natural range 0..255;  
    procedure put(item: string);
    procedure put_line(item: string);
    procedure put_hex(item: integer);
    procedure put_hex(item: system.address);
    procedure put_hex(item: System.RTS.Win32.dword);
    procedure put_dec(item: integer;width:in Count:=0);
    procedure new_line;

    -- Buffering may be used if the output will disturb the timing (e.g. in tasking tests)
    procedure Start_Buffering (Size : in Natural);
    procedure Stop_Buffering;
    procedure Flush_Buffer;
    pragma Import(C,Flush_Buffer,"rts_temp_io_flush_buffer");

end system.rts.temp_io;
