private package Ada.Text_IO.Finish is

    pragma Suppress( Elaboration_Check );

    procedure Finish_Text_IO;
    -- This procedure closes stdin, stdout and stderr if they
    -- have been opened.
    pragma export(C, Finish_Text_IO, External_Name=>"rts_finish_text_io" );

    Standard_Input_File,
    Standard_Output_File,
    Standard_Error_File : aliased File_Type;
    --| Files associated with standard input and output

    Current_Input_File,
    Current_Output_File,
    Current_Error_File : aliased File_Type;
    --| File associated with current default input and output

    Current_Input_Initialized,
    Current_Output_Initialized,
    Current_Error_Initialized : boolean := false;
    --| False until first reference to current input or output, then
    --| the file is initialized and the boolean becomes true
    
end Ada.Text_IO.Finish;
