-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.kernel.timers.calendar.spc,v $ 
-- $Revision: 1.7 $ $Date: 96/02/09 14:39:23 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with Ada.Calendar;
with System.RTS.Interface_Types;
package System.RTS.TGT.Kernel.Timers.Calendar is

  -- This package implements absolute timers,
  -- with Calendar.Time as the measure of absolute time

  -- See the abstract versions of the operations for comments, in
  -- System.RTS.TGT.Kernel.Timers.


    type Timer_Record is new Timers.Timer_Record with 
      record
	Expiration : Ada.Calendar.Time;
        Handle : Interface_Types.Simple_Handle;
      end record;

    function "<"(Left, Right : Timer_Record) return Boolean;

    procedure Suspend_Until_True_Or_Timeout(
      S : in out Threads.Suspension_Object; 
      Timeout : in out Timer_Record
    );

    procedure Signal_Abort_Upon_Timeout(
      Timeout : in out Timer_Record; 
      Level : Abort_Signals.Abort_Signal_Level);

    procedure Cancel_Timer(
      Timeout : in out Timer_Record);

end System.RTS.TGT.Kernel.Timers.Calendar;
