-- $Source: /home/dsd/d/aa/monoBANK/AA/TSP_system.rts.tgt.kernel.threads.imtimers.spc,v $ 
-- $Revision: 1.4 $ $Date: 96/04/22 11:59:33 $ $Author: akira $ 

with System.RTS.Win32;
with System.RTS.TGT.Kernel.Abort_Signals;
package System.RTS.TGT.Kernel.Threads.ImTimers is

   -- NT implementation.

   -- This package provides the low-level implementation of Timer functions.
   -- It is a child package of the Threads package because it needs
   -- visibility of the private types of Threads.

   -- This package should be "with'ed" only by the Timer packages.
    
   procedure Suspend_Until_True_Or_Timeout(
      Wait_Time : in System.RTS.Win32.DWord;
      S : in out Suspension_Object;
      Timed_Out : out Boolean);
      -- This procedure suspends the calling thread until
      -- the given suspension object is set True,
      -- or until the Timeout expires.
      -- The action of setting the suspension object to True
      -- effectively cancels the Timeout period, and no further
      -- cleanup by the client is needed.
      -- This operation can be implemented internally by setting
      -- the suspension object True from a timer interrupt handler,
      -- or by using some kind of timed-wait.
      -- If the time has already passed, no suspension occurs.

   procedure Signal_Abort_Upon_Timeout(
      Wait_Time : in System.RTS.Win32.DWord;
      Days : in Integer;
      Handle : in System.RTS.Win32.Win32_Handle; 
      Level : Abort_Signals.Abort_Signal_Level);
      -- This procedure requests that the calling thread
      -- be sent an abort signal when the Timeout expires.
      -- See also Kernel.Abort_Signals.Signal_Abort.
      -- Multiple abort timeouts may be started by a single thread.
      -- The Timeout object must have a lifetime that includes the
      -- period of time that the Timeout is active, since the
      -- address of the Timer_Record serves as the identification in the
      -- Cancel_Timer operation.
      -- If the time has already passed, the abort is immediate.

    procedure Init_Handle( Handle : out System.RTS.Win32.Win32_Handle );

      -- Conversion of type Duration to milliseconds without overflow.

      function Dur_to_Milli (Wait_Time : in Duration) return Integer;


end System.RTS.TGT.Kernel.Threads.ImTimers;
