-- $Source: /home/dsd/d/aa/monoBANK/AA/TSP_system.rts.tgt.exception_reason_pkg.spc,v $ 
-- $Revision: 1.3 $ $Date: 1996/11/06 11:11:16 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.RTS.TGT.Exception_Reason_Pkg is

    pragma Suppress (Elaboration_Check);
    pragma Preelaborate (System.RTS.TGT.Exception_Reason_Pkg);

    type Reason_Code is (
        NONE, -- no reason
        ABE,  -- Access before elaboration
        ACE,  -- Access error
        CFL,  -- Collection full
        DVZ,  -- Divide by zero
        SOF,  -- Fatal stack overflow
        ISE,  -- Internal system error
        NOC,  -- Coprocessor not present
        NOV,  -- Numeric overflow
        RNG,  -- Range error
        SOV,  -- Stack overflow
        SYN,  -- Syntax error
        UNHANDLED_IN_FINALIZATION); -- exception propagated from finalization
    for Reason_Code'size use 8;

    No_Reason : constant Reason_Code := None;

    type Access_String is access constant String;

    function Get_Reason_Message (Reason : Reason_Code) return Access_String;
    pragma Inline (Get_Reason_Message);

end System.RTS.TGT.Exception_Reason_Pkg;
