-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.float_attributes_pkg.spc,v $
-- $Revision: 1.7 $ $Date: 1996/10/30 13:35:41 $ $Author: stt $
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.RTS.TGT.Float_Attributes_Pkg is
    -- This package implements various floating-point attribute functions;
    -- See package body for summary of semantics of each operation.

    pragma Suppress( Elaboration_Check );

    type Univ_Integer is new Integer;
      -- Emitter uses Standard.Integer for "univ integer" operands

    function RTS_float_succ(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_succ, "rts_float_succ");
    pragma Global(RTS_float_succ);

    function RTS_Long_float_succ(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_succ,
                  "rts_long_float_succ");
    pragma Global(RTS_Long_float_succ);


    function RTS_float_pred(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_pred, "rts_float_pred");
    pragma Global(RTS_float_pred);


    function RTS_Long_float_pred(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_pred,
                  "rts_long_float_pred");
    pragma Global(RTS_Long_float_pred);


    function RTS_float_exponent(
      Arg: Float
    ) return Univ_Integer;
    pragma Export(Ada, RTS_float_exponent, "rts_float_exponent");
    pragma Global(RTS_float_exponent);

    function RTS_Long_float_exponent(
      Arg: Long_Float
    ) return Univ_Integer;
    pragma Export(Ada, RTS_Long_float_exponent,
                  "rts_long_float_exponent");
    pragma Global(RTS_Long_float_exponent);


    function RTS_float_fraction(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_fraction, "rts_float_fraction");
    pragma Global(RTS_float_fraction);

    function RTS_Long_float_fraction(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_fraction,
                  "rts_long_float_fraction");
    pragma Global(RTS_Long_float_fraction);


    function RTS_float_compose(
      Fraction: Float;
      Exponent: Univ_Integer
    ) return Float;
    pragma Export(Ada, RTS_float_compose, "rts_float_compose");
    pragma Global(RTS_float_compose);

    function RTS_Long_float_compose(
      Fraction: Long_Float;
      Exponent: Univ_Integer
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_compose,
                  "rts_long_float_compose");
    pragma Global(RTS_Long_float_compose);


    function RTS_float_scaling(
      Arg: Float;
      Adjustment: Univ_Integer
    ) return Float;
    pragma Export(Ada, RTS_float_scaling, "rts_float_scaling");
    pragma Global(RTS_float_scaling);

    function RTS_Long_float_scaling(
      Arg: Long_Float;
      Adjustment: Univ_Integer
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_scaling,
                  "rts_long_float_scaling");
    pragma Global(RTS_Long_float_scaling);


    function RTS_float_floor(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_floor, "rts_float_floor");
    pragma Global(RTS_float_floor);

    function RTS_Long_float_floor(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_floor,
                  "rts_long_float_floor");
    pragma Global(RTS_Long_float_floor);


    function RTS_float_ceiling(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_ceiling, "rts_float_ceiling");
    pragma Global(RTS_float_ceiling);

    function RTS_Long_float_ceiling(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_ceiling,
                  "rts_long_float_ceiling");
    pragma Global(RTS_Long_float_ceiling);


    function RTS_float_rounding(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_rounding, "rts_float_rounding");
    pragma Global(RTS_float_rounding);

    function RTS_Long_float_rounding(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_rounding,
                  "rts_long_float_rounding");
    pragma Global(RTS_Long_float_rounding);


    function RTS_float_unbiased_rounding(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_unbiased_rounding,
                  "rts_float_unbiased_rounding");
    pragma Global(RTS_float_unbiased_rounding);

    function RTS_Long_float_unbiased_rounding(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_unbiased_rounding,
                  "rts_long_float_unbiased_rounding");
    pragma Global(RTS_Long_float_unbiased_rounding);


    function RTS_float_truncation(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_truncation, 
                  "rts_float_truncation");
    pragma Global(RTS_float_truncation);

    function RTS_Long_float_truncation(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_truncation,
                  "rts_long_float_truncation");
    pragma Global(RTS_Long_float_truncation);


    function RTS_float_remainder(
      X, Y: Float
    ) return Float;
    pragma Export(Ada, RTS_float_remainder, "rts_float_remainder");
    pragma Global(RTS_float_remainder);

    function RTS_Long_float_remainder(
      X, Y: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_remainder,
                  "rts_long_float_remainder");
    pragma Global(RTS_Long_float_remainder);


    function RTS_float_adjacent(
      X, Towards: Float
    ) return Float;
    pragma Export(Ada, RTS_float_adjacent, "rts_float_adjacent");
    pragma Global(RTS_float_adjacent);

    function RTS_Long_float_adjacent(
      X, Towards: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_adjacent,
                  "rts_long_float_adjacent");
    pragma Global(RTS_Long_float_adjacent);


    function RTS_float_copy_sign(
      Value, Sign: Float
    ) return Float;
    pragma Export(Ada, RTS_float_copy_sign, "rts_float_copy_sign");
    pragma Global(RTS_float_copy_sign);

    function RTS_Long_float_copy_sign(
      Value, Sign: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_copy_sign,
                  "rts_long_float_copy_sign");
    pragma Global(RTS_Long_float_copy_sign);


    function RTS_float_leading_part(
      Arg: Float;
      Radix_Digits: Univ_Integer
    ) return Float;
    pragma Export(Ada, RTS_float_leading_part,
                  "rts_float_leading_part");
    pragma Global(RTS_float_leading_part);

    function RTS_Long_float_leading_part(
      Arg: Long_Float;
      Radix_Digits: Univ_Integer
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_leading_part,
                  "rts_long_float_leading_part");
    pragma Global(RTS_Long_float_leading_part);


    function RTS_float_machine(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_machine, "rts_float_machine");
    pragma Global(RTS_float_machine);

    function RTS_Long_float_machine(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_machine,
                  "rts_long_float_machine");
    pragma Global(RTS_Long_float_machine);


    function RTS_float_model(
      Arg: Float
    ) return Float;
    pragma Export(Ada, RTS_float_model, "rts_float_model");
    pragma Global(RTS_float_model);

    function RTS_Long_float_model(
      Arg: Long_Float
    ) return Long_Float;
    pragma Export(Ada, RTS_Long_float_model,
                  "rts_long_float_model");
    pragma Global(RTS_Long_float_model);

end System.RTS.TGT.Float_Attributes_Pkg;
