-- $Source: /home/dsd/d/aa/monoBANK/AA/system.rts.tgt.handler_conversions.spc,v $ 
-- $Revision: 1.2 $ $Date: 96/10/29 15:09:11 $ $Author: bethc $ 
with Ada.Interrupts;
with System.RTS.Protected_Types_Pkg;
with System.RTS.Interface_Types;
package System.RTS.TGT.Handler_Conversions is 

    package RPT renames System.RTS.Protected_Types_Pkg;
    package IFT renames System.RTS.Interface_Types;

    function Current_Handler (Interrupt : Ada.Interrupts.Interrupt_Id)
       return Ada.Interrupts.Parameterless_Handler;
    --* EFFECTS
    -- Returns the user-specified handler if attached. Returns
    -- Default_Handler if not reserved and not attached.
    -- If Interrupt is reserved, Interrupt_Error is returned.

    procedure Attach_Handler(
        New_Handler : Ada.Interrupts.Parameterless_Handler;
        Interrupt   : Ada.Interrupts.Interrupt_Id
    );
    --* EFFECTS
    -- Attaches the specified handler to an unreserved interrupt,
    -- thereby overriding the current handler (which may be the default).
    -- Interrupt_Error will be raised if Interrupt is reserved.
    -- When implemented for Ada9X the following effects will be added:
    -- NEW_Handler = null will restore the default treatment.  If pragma
    -- Interrupt_Handler is not present in the protected object
    -- containing New_Handler, then Program_Error will be raised.

    procedure Exchange_Handler
       (Old_Handler : out Ada.Interrupts.Parameterless_Handler;
        New_Handler : Ada.Interrupts.Parameterless_Handler;
        Interrupt   : Ada.Interrupts.Interrupt_Id
    );
    --* EFFECTS
    -- Similar to Attach_Handler except that the previous handler is
    -- returned.

    procedure Detach_Handler(
        Interrupt : Ada.Interrupts.Interrupt_Id
    );

    function Object_from_Parameterless_Handler(
        Handler : Ada.Interrupts.Parameterless_Handler
    ) return RPT.PO_Access;

    function Make_Parameterless_Handler(
        PO : IFT.PO_Handle;
        Handler : System.Address
    ) return Ada.Interrupts.Parameterless_Handler;

end System.RTS.TGT.Handler_Conversions;


