-- $Source: /home/dsd/d/aa/monoBANK/AA/TSP_system.rts.tgt.heap_pkg.spc,v $ 
-- $Revision: 1.3 $ $Date: 96/09/18 16:50:41 $ $Author: akira $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.RTS.TGT.Heap_Pkg is

    Max_Align : constant := Word_Size / Storage_Unit;
    -- target dependent alignment value

    -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * --

    Min_Alloc : Natural := 8192 - 8;
    -- Minimum size that heap manager will request through Get_Heap_Chunk.

    -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * --

    Use_Locking : Boolean := True;
    -- Indicates whether the heap manager will enforce mutual exclusion
    -- when accessing the heap.

    -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * --

    function Get_Heap_Chunk( Size : in Natural ) return Address;

        --* OVERVIEW
        -- Get_Heap provides the basic mechanism of acquiring a
        -- heap chunk.
        --
        --* EFFECTS
        -- Get_Heap will reserve a chunk of heap space equal to requested
        -- Size in storage units and aligned to the proper target dependent
	-- boundary.
	-- It will return the address of this newly acquired heap chunk.
	-- If sufficient space is not available, STORAGE_ERROR will be raised.

    -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * -- * --

private

    pragma Export (C, Use_Locking, "rts_heap_use_locking");

end System.RTS.TGT.Heap_Pkg;
