with Win32, Win32.WinUser, Win32.WinDef, gbObjects;
use type Win32.Int, Win32.Bool, Win32.WinDef.hWnd;
use gbObjects;

package Window1 is
  Form            : gbMainWindow;
  Text1           : gbTextBox;
  File_MN         : gbMenuItem;
  New_MN          : gbMenuItem;
  Open_MN         : gbMenuItem;
  Save_MN         : gbMenuItem;
  Save_As_MN      : gbMenuItem;
  Separator_MN    : gbMenuItem;
  Exit_MN         : gbMenuItem;
  Edit_MN         : gbMenuItem;
  Copy_MN         : gbMenuItem;
  procedure Initialize_Form;
end Window1;

with Win32.CommDlg, Win32.WinBase;

package body Window1 is
  procedure Open_MN_Selected is 
    OFN      : aliased Win32.CommDlg.OPENFILENAME;
    Filter   : constant String := "Text Files" & gbNullChar & "*.TXT" & gbNullChar & gbNullChar;
    Ext      : constant String := "TXT" & gbNullChar; 
    FileName : String(1..256) := String'(1..256 => gbNullChar);
    Len      : Win32.Long;
    L        : Win32.Long;
    I        : Win32.UInt;
    FH       : Win32.WinDef.HFile;
    B        : Win32.Bool;
  begin
    OFN.lStructSize       := Win32.Dword(Win32.Commdlg.Openfilename'Size / 8);
    OFN.hwndOwner         := Handle(Form);
    OFN.hInstance         := null;
    OFN.lpstrFilter       := Convert(Filter);
    OFN.lpstrCustomFilter := null;
    OFN.nMaxCustFilter    := 0;
    OFN.nFilterIndex      := 0;
    OFN.lpstrFile         := Convert(FileName);
    OFN.nMaxFile          := 256;
    OFN.lpstrFileTitle    := null;
    OFN.nMaxFileTitle     := 0;
    OFN.lpstrInitialDir   := null;
    OFN.lpstrTitle        := null;
    OFN.Flags             := Convert(Win32.CommDlg.OFN_FILEMUSTEXIST + Win32.CommDlg.OFN_PATHMUSTEXIST + 
                              Win32.CommDlg.OFN_HIDEREADONLY + Win32.CommDlg.OFN_NONETWORKBUTTON);
    OFN.nFileOffset       := 0;
    OFN.nFileExtension    := 0;
    OFN.lpstrDefExt       := Convert(Ext);
    OFN.lCustData         := 0;
    OFN.lpfnHook          := null;
    OFN.lpTemplateName    := null;
  
  
    B := Win32.CommDlg.GetOpenFileName(OFN'unchecked_access);
  
    if FileName(1) /= gbNullChar and B /= 0 then
      FH := Win32.WinBase.lopen(Convert(FileName), Win32.WinBase.OF_READ);
      LEN := Win32.WinBase.llseek(FH, 0, Win32.WinBase.FILE_END);
      L := Win32.WinBase.llseek(FH, 0, Win32.WinBase.FILE_BEGIN);
      declare
        S : String(1..Integer(LEN));
      begin
        I := Win32.WinBase.lread(FH, S'address, Win32.UInt(LEN));
        Text(Text1, S);
        Text(Window1.Form, "File: " & TrimString(FileName));
      end; 
      FH := Win32.WinBase.lclose(FH);
    end if;
  
  end Open_MN_Selected;

  procedure Initialize_Form is
  begin
    ScrollBars(Text1, gbBoth);
    Text(Text1, "");
    Move(Text1, 20, 20, 401, 251);

    Open_MN.Selected := Open_MN_Selected'Access;

    LoadMenu(Form, "Window1");
    Text(Form, "Window1");
    Move(Form, 2, 109, 461, 331);
    Visible(Form, gbTrue);
  end Initialize_Form;
begin
  Initialize_Form;
end Window1;


with gbObjects;
with Window1;

procedure Main is begin
  gbObjects.gbStartApplication;
end Main;


