with Ada.Unchecked_Deallocation;

with Ada_Store.Trading.Transaction.Sale;
with Ada_Store.User;

package Ada_Store.PoST.Application.Sequences is

   --
   -- start state driver.
   --
   procedure Start;

private
   type Sale_Ptr is access Trading.Transaction.Sale.Instance;
   procedure Free is new Ada.Unchecked_Deallocation(Trading.Transaction.Sale.Instance,
						    Sale_Ptr);

   type State_Proc is access procedure;

   procedure Wait_For_User;
   procedure Main_Trading_Loop;
   procedure Basket_Loop;
   procedure Tendering_Loop;

   Next_State   : State_Proc := Wait_For_User'Access;
   Current_Sale : Sale_Ptr   := null;
   Current_User	: User.Instance;

end Ada_Store.PoST.Application.Sequences;
