with Ada_Store.PoST.Input_Queue;

package Ada_Store.PoST.Device.Display is

   type Instance	is new Ada_Store.PoST.Device.Instance with private;

   procedure Open
     (Display : in out Instance);
    
   function  Lines
     (Display : in Instance)
      return Positive;

   function  Columns
     (Display : in Instance)
      return Positive;

   procedure Write
     (Display : in out Instance;
      Line    : in     Positive;
      Text    : in     String;
      Center  : in     Boolean	:= false);
   
   procedure Clear
     (Display : in out Instance;
      Line    : in     Positive);

   procedure Clear
     (Display : in out Instance);

   procedure Flush
     (Display	 : in out Instance;
      Flush_Mode : in     Device_Mode);

   procedure Accept_Input
     (Display : in out Instance;
      Input   : in     Input_Queue.Message_Ptr);
	
private
   type Memory;
   type Memory_Ptr	is access Memory;

   type Instance       	is new Ada_Store.PoST.Device.Instance with 
      record
         Lines		: Positive 	:= 1;
	 Columns	: Positive 	:= 1;
	 Internal	: Memory_Ptr	:= null;
      end record;

end Ada_Store.PoST.Device.Display;
