package Ada_Store.Trading.Tender is

   type Instance 	is private;
   
   type Identifier	is new Natural range 0 .. 20;
   
   function  Lookup
     (Tender_ID	: in Identifier)
      return Instance;

   procedure Create_New
     (Tender_ID	  : in Identifier;
      Description : in Short_Description;
      Min_Amount  : in Currency;
      Max_Amount  : in Currency);

   procedure Remove
     (Tender_ID	: in Identifier);

   function  Authorise
     (Tender : in Instance;
      Amount : in Currency)
      return Boolean;

   function  Description
     (Tender : in Instance)
      return Short_Description;

   Invalid_Identifier : exception;

private
   type Instance 	is
      record
	 Tender_ID	: Identifier := 0;
	 Description	: Short_Description := (others => ' ');
         Min_Amount     : Currency   := 0.00;
         Max_Amount     : Currency   := 0.00;
      end record;
   
end Ada_Store.Trading.Tender;    


