with Ada_Store.Log;

package Ada_Store.Trading.Transaction is
   pragma Elaborate_Body (Ada_Store.Trading.Transaction);
   type Instance     is abstract new Ada_Store.Log.Element with private;

   procedure Complete
     (Basket : in out Instance) is abstract;

   procedure Void
     (Basket : in out Instance) is abstract;

   Unable_To_Complete    : exception;

private
   type State is ( Incomplete, Complete, Void );

   type Instance is abstract new Ada_Store.Log.Element with 
      record
	 Current_State : State := Incomplete;
      end record;

end Ada_Store.Trading.Transaction;
