-------------------------------------------------------------------------------
--
-- package Ada_Store		(c) Simon Johnston 1995				1.0.0
--
-- This package is the top level of the Point of Sale Terminal application
-- developed for the book 'Ada-95 a guide for C and C++ programmers'.
--
-------------------------------------------------------------------------------
package Ada_Store is

  pragma Pure(Ada_Store);

  -----------------------------------------------------------------------------
  -- Basic Types used throughout application
  --
  type Quantity		 is new Positive;
  type Currency 	 is delta 0.01  digits 8;	  -- 999,999.99
  type Weight   	 is delta 0.001 digits 6;	  -- 999.999
  type Percentage_Base	 is delta 0.01  digits 5;	  -- 999.99
  subtype Percentage	 is Percentage_Base range 0.00 .. 100.00;

  type Short_Description is new String(1 .. 18);

  -----------------------------------------------------------------------------
  -- Some constants used throughout application
  --
  System_Name		 : constant String := "Ada Store";
  System_Version	 : constant String := "GENERIC_1.0.0";

end Ada_Store;
