-- ***************************************************************************
-- *                    Subprogram_Tests.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This short program illustrates some simple subprograms, it
-- *    is best to read the subprograms at the beginning first before the
-- *    main body of the outer procedure.
-- * Inputs:  None.
-- * Outputs: Some simple text messages.
-- ***************************************************************************
with Ada.Text_IO;
use  Ada.Text_IO;
with Ada.Integer_Text_IO;
use  Ada.Integer_Text_IO;

procedure Subprogram_Tests is

   -- the following subprograms are dealt with later on.
   function Min(A, B : Integer) return Integer;
   procedure Swap(A, B : in out Integer);
   procedure Say_Boo(To_Who : in String := "to a goose");

   function Min(A, B : Integer) return Integer is
   begin
      if A < B then
	 return A;
      else
	 return B;
      end if;
   end Min;

   procedure Swap(A, B : in out Integer) is
      Temp : Integer := A;
   begin
      A := B;
      B := Temp;
   end Swap;

   procedure Say_Boo(To_Who : in String := "to a goose") is
   begin
      Put_Line("Saying boo " & To_Who);
   end Say_Boo;
   -- end of subprograms.

   -- please ignore these declarations, see chapter 3.
   Test_1, Test_2, Test_3 : Integer;
   -- end of declarations.

begin
   pragma Page;
   Function_Tests:
      begin
	 Test_1 := 1;
	 Test_2 := 10;
	 
	 Test_3 := Min(Test_1, Test_2);
         Put("Min is ");
         Put(Test_3);
         New_Line;

	 Test_3 := Min(A => Test_1, B => Test_2);
         Put("Min is ");
         Put(Test_3);
         New_Line;
      end Function_Tests;

   pragma Page;
   Procedure_Tests:
      begin
	 Swap(Test_1, Test_2);
	 Swap(A => Test_1, B => Test_2);
         Put(Test_1);
         Put(Test_2);
         New_Line;

	 Say_Boo(To_Who => "the reader");
	 Say_Boo;
      end Procedure_Tests;

end Subprogram_Tests;
