-- ***************************************************************************
-- *                         Access_Tests.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Examples of Ada95 general access types.
-- * Inputs:  None.
-- * Outputs: This example does not compile.
-- ***************************************************************************

procedure Access_Tests2 is

   type Integer_Ptr       is access all      Integer;
   type Const_Integer_Ptr is access constant Integer;

   Ptr_1 : Integer_Ptr;
   Const_Ptr_1 : Const_Integer_Ptr;

   Variable_1 : Integer;
   Constant_1 : constant Integer := 1;

   Variable_2 : aliased Integer;
   Constant_2 : aliased constant Integer := 1;

begin

   Ptr_1 := Variable_1'Access; -- illegal
   Const_Ptr_1 := Constant_1'Access; -- illegal

   Ptr_1       := Variable_2'Access; -- legal
   Const_Ptr_1 := Constant_2'Access; -- legal

   Ptr_1       := Constant_2'Access; -- illegal
   Const_Ptr_1 := Variable_2'Access; -- legal

end Access_Tests2;
