-- ***************************************************************************
-- *                         Callback_Tests.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This example shows how Ada95 subprogram access types can be
-- *    used to implement callback functions.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

procedure Callback_Tests is

   type Device_ID is new Integer;

   -- lots of things missing.

   type Read_Callback is access procedure 
     (Device   : in  Device_ID;
      Read_ID  : in  Integer);

   procedure Async_Read
     (Device   : in  Device_ID; 
      Callback : in  Read_Callback;
      Read_ID  : out Integer);
   procedure Async_Read
     (Device   : in  Device_ID;
      Callback : in  Read_Callback;
      Read_ID  : out Integer) is
   begin

      -- do something ...
      Callback.all(Device, Read_ID);

   end Async_Read;

   -- ************************************************************************

   procedure My_Callback(Device : in Device_ID; Read_ID : Integer) is
   begin
      null;
   end My_Callback;

   Device  : Device_ID;
   Read_ID : Integer;

begin

   Async_Read(Device, My_Callback'Access, Read_ID);

end Callback_Tests;
