-- ***************************************************************************
-- *                         Enum_Tests.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This file contains examples on declaring and using some
-- *    enumeration types.
-- * Inputs:  None.
-- * Outputs: This example, compiles but fails to run.
-- ***************************************************************************
with Ada.Text_IO;

procedure Enum_Tests is
   type Day is (Monday,   Tuesday, Wednesday, Thursday, Friday,
                Saturday, Sunday);

   subtype Week_Day is Day range Monday .. Friday;
   subtype Weekend  is Day range Saturday .. Sunday;

   Today     : Day     := Tuesday;
   Day_Off   : Integer := Sunday;  -- type mismatch error.

   Tomorrow  : Day     := 2;       -- type mismatch error.

   Day_Off2  : Integer := Day'Pos(Sunday);
   Tomorrow2 : Day     := Day'Val(2);

   Day_Off3  : Day     := Day'Val(20);  -- raise Constraint_Error.

begin
   if Today in Week_Day then
      Ada.Text_IO.Put_Line("Go to work");
   else
      Ada.Text_IO.Put_Line("Stay in bed");
   end if;
end Enum_Tests;
