-- ***************************************************************************
-- *                          Real_Types.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Although simple, this example demonstrates the declaration
-- *    of some real types for mathematical applications.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

procedure Real_Types is

   type Floating_Point_Type is digits 10;

   A : Floating_Point_Type := 1.0;
   A_Digits : Integer := Floating_Point_Type'Digits;


   type Fixed_Point_Type is delta 0.1 range 0.0 .. 100.0;

   B : Fixed_Point_Type := 1.0;
   B_Delta : Float   := Fixed_Point_Type'Delta;
   B_Fore  : Integer := Fixed_Point_Type'Fore;
   B_Aft   : Integer := Fixed_Point_Type'Aft;

   type Decimal_Type is delta 0.01 digits 9;

   C : Decimal_Type := 1.0;
   C_Delta : Float   := Decimal_Type'Delta;
   C_Fore  : Integer := Decimal_Type'Fore;
   C_Aft   : Integer := Decimal_Type'Aft;
   C_Scale : Integer := Decimal_Type'Scale;

begin
   null;
end Real_Types;
