-- ***************************************************************************
-- *                         Sort_Test2.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This example (does not compile) shows how the bubble sort
-- *    can be immediately used against more complex, real-world data.
-- * Inputs:  None.
-- * Outputs: This example does not compile (please add details for the record
-- *    Area_Details to complete the example).
-- ***************************************************************************

with Bubble_Sort;

procedure Sort_Test2 is

   type Area_Details is
      record
         Area_Code      : Positive;
         Representative : Person_ID;
         Area_Size      : Natural;
         Sales_To_Date  : Decimal;
      end record;

   type Sales_Figures is array(Positive range <>) of Area_Details;

   function  Compare_Size(L, R : Area_Details) return Boolean;
   procedure Sort_By_Size is new Bubble_Sort(Positive, 
                                             Area_Details,
                                             Sales_Figures,
                                             Compare_Size);

   function  Compare_Sales(L, R : Area_Details) return Boolean;
   procedure Sort_By_Sales is new Bubble_Sort(Positive, 
                                              Area_Details,
                                              Sales_Figures,
                                              Compare_Sales);

   -- declare Print_Sales_Data and Sales_Array
begin
   Print_Sales_Data(Sales_Array);

   Sort_By_Size(Sales_Array);
   Print_Sales_Data(Sales_Array);

   Sort_By_Sales(Sales_Array);
   Print_Sales_Data(Sales_Array);
end Sort_Test2;
