-- ***************************************************************************
-- *                         Domesticated.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: How to achieve a measure of multiple inheritance support in
-- *    a programming language which does not support it.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

with Animal;

generic

   type Wild_Animal is new Animal.Instance with private;

package Domesticated is

   type Instance is new Wild_Animal with private;

   procedure Set_Purpose
     (Domesticated_Animal : in out Instance;
      Purpose             : in     String);

   function  Get_Purpose
     (Domesticated_Animal : in     Instance)
      return String;

private
   type Instance is new Wild_Animal with
      record
         Purpose : String(1 .. 30);
      end record;
end Domesticated;
