-- ***************************************************************************
-- *                         Test3.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Another enhancement to the test 06
-- * Inputs:  None.
-- * Outputs: The procedure What_Is should tell you the type of each object 
-- *    passed.
-- ***************************************************************************

with Ada.Text_IO;

with Animal;
use  Animal;
with Animal.Cat;
with Animal.Dog;

procedure Test3 is
   type Animal_Ptr is access all Animal.Instance'Class;

   procedure What_Is(Animal : Animal_Ptr) is
   begin
      if Animal.all in Animal.Cat.Instance'Class then

         Ada.Text_IO.Put_Line("Animal is a cat");
      elsif Animal.all in Animal.Dog.Instance'Class then

         Ada.Text_IO.Put_Line("Animal is a dog");
      else

         Ada.Text_IO.Put_Line("Animal is an unknown animal");
      end if;
   end What_Is;

   An_Other : Animal.Instance;
   A_Cat    : Animal.Cat.Instance;
   A_Dog    : Animal.Dog.Instance;
begin

   What_Is(A_Cat);
   What_Is(A_Dog);
   What_Is(An_Other);
end Test3;
