-- ***************************************************************************
-- *                         Test4.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Another enhancement of test 06
-- * Inputs:  None.
-- * Outputs: This example does not compile.
-- ***************************************************************************

with Ada.Text_IO;

with Animal;
use  Animal;
with Animal.Cat;
with Animal.Dog;

procedure Test4 is
   subtype Animal_Class is Animal.Instance'Class;
   type    Animal_Ptr   is access all Animal.Instance'Class;

   Some_Animal : Animal_Class;                       -- illegal.
   A_Cat       : aliased Animal.Cat.Instance; -- legal.
   An_Animal   : Animal_Class := A_Cat;              -- now legal.
   Animal      : Animal_Ptr;
begin
   Ada.Text_IO.Put_Line(Name(A_Cat));        -- normal call.
   Ada.Text_IO.Put_Line(Name(An_Animal));    -- normal call.

   Animal := A_Cat'Access;
   Ada.Text_IO.Put_Line(Name(An_Animal));    -- dispatched.
end Test4;
