-- ***************************************************************************
-- *                         Three_Tasks.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Shows three concurrent tasks running.
-- * Inputs:  None.
-- * Outputs: Each task will print it's passed identifier, the body will print
-- *    it's message. The order of messages is implementation and operating
-- *    system specific.
-- ***************************************************************************

with Ada.Text_IO;

procedure Three_Tasks is

   task type X(id : Integer);
 
   task body X is
   begin
      loop
         Ada.Text_IO.Put_Line("task" & 
                              Integer'Image(id) & 
                              " here");
      end loop;
   end X;

   Task_1 : X(1);
   Task_2 : X(2);
   Task_3 : X(3);
begin
   loop
      Ada.Text_IO.Put_Line("Three_Tasks got here");
   end loop;
end Three_Tasks;
