-- ***************************************************************************
-- *                         Task_Test1.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This example shows how to use the Ada.Task_Attributes 
-- *    package to add custom data to tasks.
-- * Inputs:  None.
-- * Outputs: Details using the Ada.Task_Attributes package.
-- ***************************************************************************

with Ada.Task_Attributes;
with Ada.Text_IO;
use  Ada;

procedure Task_Test1 is

   package Threaded is new Task_Attributes(Boolean,
					   True);

   task type X is
      entry Start;
   end X;

   task body X is
   begin
      Threaded.Set_Value(False);
      accept Start do
	 null;
      end Start;
   end X;

   An_X : X;
begin

   Text_IO.Put_Line("Current Task = " &
		    Boolean'Image(Threaded.Value));

   Text_IO.Put_Line("An_X Value = " &
		    Boolean'Image(Threaded.Value(An_X'Identity)));
end Task_Test1;
