-- ***************************************************************************
-- *                         Final.ads
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: How to specify a controlled type.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

with Ada.Finalization;

package Final is

   type Example is new Ada.Finalization.Controlled with 
      record
         Int_Data : Integer;
      end record;

private
   procedure Initialize (Object : in out Example);
   procedure Adjust     (Object : in out Example);
   procedure Finalize   (Object : in out Example);

end Final;

