-- ***************************************************************************
-- *                         Time_Test.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This example shows some simple use of the time facilities
-- *    provided by the package Ada.Calendar.
-- * Inputs:  None.
-- * Outputs: The date.
-- ***************************************************************************

with Ada.Calendar;
with Ada.Text_IO;
use  Ada;

procedure Time_Test is

   function Image(A_Time : Calendar.Time) return String is
      A_String : String(1 .. 80);
      Year     : Calendar.Year_Number;
      Month    : Calendar.Month_Number;
      Day      : Calendar.Day_Number;
      Seconds  : Calendar.Day_Duration;
   begin
      Calendar.Split(A_Time, Year, Month, Day, Seconds);

      declare
	 Year_String : String := Calendar.Year_Number'Image(Year);
	 Month_String : String := Calendar.Month_Number'Image(Month);
	 Day_String : String := Calendar.Day_Number'Image(Day);
	 Seconds_String : String := Calendar.Day_Duration'Image(Seconds);
      begin
	 declare
	    R_String : String := Year_String & Month_String;
	 begin
	    return R_String;
	 end ;
      end ;
   end Image;

begin
   Text_IO.Put_Line(Image(Calendar.Clock));
end Time_Test;
   
