-- ***************************************************************************
-- *                         C_Test4.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This example uses the C pointers support to call putstring.
-- * Inputs:  None.
-- * Outputs: "hello world".
-- ***************************************************************************

with Interfaces.C;
use type Interfaces.C.char_array;
with Interfaces.C.Pointers;

procedure C_Test4 is

   package C_char is 
      new Interfaces.C.Pointers(Interfaces.C.size_T,
					   Interfaces.C.char,
					   Interfaces.C.char_array,
					   Interfaces.C.nul);

   procedure PutString(S : C_char.Pointer);

   pragma Import(C, PutString, "putstring");

   C_Str : Interfaces.C.char_array := "hello world" & 
                                      Interfaces.C.nul;
begin

   PutString(C_Str(C_Str'First)'Access);

end C_Test4;
