-- ***************************************************************************
-- *                         Decimal_Test.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: Some simple edited IO using decimal types.
-- * Inputs:  None.
-- * Outputs: This test will compile with the GNAT compilers, but not the 
-- *    ObjectAda or AppletMagic compilers which do not support Annex F.
-- ***************************************************************************

with Ada.Text_IO;
with Ada.Text_IO.Editing;
use  Ada;

procedure Decimal_Test is

   type Decimal is delta 0.01 digits 8;

   package Decimal_IO is new Text_IO.Editing.Decimal_Output(Num => Decimal);

   A_Decimal : Decimal;
   Picture   : Text_IO.Editing.Picture;
begin

   Picture := Text_IO.Editing.To_Picture("-9.99");
   A_Decimal := -1.0;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("+9.99");
   A_Decimal := -1.0;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("-9.99");
   A_Decimal := +1.0;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("+9.99");
   A_Decimal := +1.0;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("9999.99");
   A_Decimal := 1234.56;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("9_999.99");
   A_Decimal := 1234.56;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("$_$$9.99-");
   A_Decimal := 1.99;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("$_$$9.99-");
   A_Decimal := 0.50;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("$_$$9.99-");
   A_Decimal := -2.99;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("$*_**9.99");
   A_Decimal := 1.99;
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

   Picture := Text_IO.Editing.To_Picture("$*_**9.99");
   A_Decimal := 123456.99;
   Text_IO.Put_Line("About to raise exception Picture_Error ...");
   Text_IO.Put_Line(Decimal_IO.Image(A_Decimal, Picture));

end Decimal_Test;
