-- ***************************************************************************
-- *                         Import_Test.adb 
-- * Copyright (c) Simon Johnston & Addison Wesley Longman 1996.
-- *
-- * Description: This package specification is an interface between Ada and
-- *    C code.
-- * Inputs:  None.
-- * Outputs: None.
-- ***************************************************************************

with Interfaces;

package Import_Test1 is

   function  C_Get_Data return Interfaces.Unsigned_32;

   procedure C_Set_Data(Data : Interfaces.Unsigned_32);

   pragma Import(Convention    => C,
		      Entity        => C_Get_Data,
		      External_Name => "getdata",
		      Link_Name     => "_getdata");

   pragma Import(Convention    => C,
		      Entity        => C_Set_Data,
                 External_Name => "setdata");

   procedure Data_Changed;

   pragma Export(Convention    => C,
		      Entity        => Data_Changed,
		      External_Name => "datachanged",
		      Link_Name     => "_datachanged");

   type Data_2 is
      record
	    A : Integer;
      end record;

   pragma Convention(Convention => C,
		          Entity => Data_2);

   pragma Linker_Options("data.obj");

end Import_Test1;
