--[pack_factorial.ads] Specification
PACKAGE Pack_factorial IS
  TASK TYPE Task_factorial IS                -- Specification
    ENTRY start( f:IN Positive );            -- Rendezvous
    ENTRY finish( result:OUT Positive );     -- Rendezvous
  END Task_factorial;
END Pack_factorial;

--[pack_factorial.adb] Implementation
PACKAGE BODY Pack_factorial IS
  TASK BODY Task_factorial IS                -- Implementation
    factorial : Positive;
    answer    : Positive := 1;
  BEGIN
    ACCEPT start( f:IN Positive ) DO         -- Factorial
      factorial := f;
    END start;
    FOR i IN 2 .. factorial LOOP             -- Calculate
      answer := answer * i;
    END LOOP;
    ACCEPT finish( result:OUT Positive ) DO -- Return answer
      result := answer;
    END finish;
  END Task_factorial;
END Pack_factorial;

--[pack_is_a_prime.ads] Specification
PACKAGE Pack_is_a_prime IS
  TASK TYPE Task_is_prime IS                 -- Specification
    ENTRY start( p:IN Positive );            -- Rendezvous
    ENTRY finish( result:OUT Boolean );      -- Rendezvous
  END Task_is_prime;
END Pack_is_a_prime;

--[pack_is_a_prime.adb] Implementation
PACKAGE BODY Pack_is_a_prime IS
  TASK BODY Task_is_prime IS                 -- Implementation
    prime : Positive;
    answer: Boolean := TRUE;
  BEGIN
    ACCEPT start( p:IN Positive ) DO         -- Factorial
      prime := p;
    END start;
    FOR i IN 2 .. prime-1 LOOP               -- Calculate
      IF prime REM i = 0 THEN
        answer := FALSE; EXIT;
      END IF;
    END LOOP;
    ACCEPT finish( result:OUT Boolean ) DO  -- Return answer
      result := answer;
    END finish;
  END Task_is_prime;
END Pack_is_a_prime;

--[execute_threads.adb] Procedure
WITH Simple_io, Pack_factorial, Pack_is_a_prime;
USE  Simple_io, Pack_factorial, Pack_is_a_prime;
PROCEDURE main180 IS
  thread_1 : Task_factorial;
  thread_2 : Task_factorial;
  thread_3 : Task_is_prime;
  factorial: Positive;
  prime    : Boolean;

BEGIN
  thread_1.start(5);            -- Start factorial calculation
  thread_2.start(7);            -- Start factorial calculation
  thread_3.start(97);           -- Start is_prime calculation

  put("Factorial  5 is ");
  thread_1.finish( factorial ); -- Obtain result
  put( factorial ); new_line;

  put("Factorial  8 is ");
  thread_2.finish( factorial ); -- Obtain result
  put( factorial ); new_line;

  put("97 is a prime is ");
  thread_3.finish( prime );     -- Obtain result
  IF prime THEN put("True"); ELSE put("False"); END IF; new_line;

END main180;
