with Ada.Unchecked_Conversion;
with Interfaces.C.Strings;
with System;
with Win32.Windef;
with Win32.Wingdi;
with Win32.Winuser;

package Windows.Data is
  use type Win32.Dword;
  use type Win32.Uint;

   function Convert_Chars_Ptr_To_Lpcstr is new
     Ada.Unchecked_Conversion
       (Source =>
         Interfaces.C.Strings.Chars_Ptr,
        Target =>
         Win32.Lpcstr);

   function Convert_Integer_To_Hbrush is new
     Ada.Unchecked_Conversion
       (Source =>
         Integer,
        Target =>
         Win32.Windef.Hbrush);

   Class_Name              : constant Interfaces.C.Strings.Chars_Ptr := 
     Interfaces.C.Strings.New_String
       (Str =>"HexCalc");

   Window_Class_Style      : constant Win32.Uint := 
     Win32.Winuser.Cs_Hredraw or 
     Win32.Winuser.Cs_Vredraw;

   Window_Class_CbClsExtra : constant Win32.Int := 0;

   Window_Class_CbWndExtra : constant Win32.Int := 
     Win32.Winuser.Dlgwindowextra;

   Window_Class_Cursor     : constant Win32.Windef.Hcursor :=
     Win32.Winuser.Loadcursor
       (Hinstance =>
         System.Null_Address,
        Lpcursorname =>
         Win32.Lpcstr
          (Win32.Winuser.Idc_Arrow));

   Window_Class_Background : constant Win32.Windef.Hbrush := 
     Convert_Integer_To_Hbrush
       (S =>
         Win32.Winuser.Color_Window + 1); 

   Window_Class_Menu_Name  : constant Win32.Lpcstr := 
     null;

   Window_Class_Class_Name  : constant Win32.Lpcstr :=
     Convert_Chars_Ptr_To_Lpcstr
       (S =>
         Class_Name);

   Message_Filter_Minimum  : constant Win32.Uint := 0;

   Message_Filter_Maximum  : constant Win32.Uint := 0;

 end Windows.Data;
