-- Filename: data.ads
--
-- This is the conversion of Petzold's Win 95
-- Chapter 4 program clover.  This file contains
-- the data which is common but customized for each
-- application.
-- 
with System;

with Win32;
with Win32.Windef;
with Win32.Wingdi;
with Win32.Winuser;

use type Win32.Char_Array;
use type Win32.Uint;


package Windows.Data is

   Caption : constant Win32.Char_Array := 
     "Clover Program" & Win32.Nul;
   Class_Name: constant Win32.Char_Array := "Clover" & win32.Nul;
   Paint_Record : aliased win32.Winuser.Paintstruct;
   --Rect : aliased win32.WinDef.Rect;
   Window_Class : aliased Win32.Winuser.Wndclass;

   Window_Handle : Win32.WinDef.Hwnd;            -- our main window handle
   Message : aliased Win32.Winuser.Msg;

   Window_Class_Style : constant Win32.Uint := 
     Win32.Winuser.Cs_Hredraw or 
     Win32.Winuser.Cs_Vredraw;
   Window_Class_CbClsExtra : constant Win32.Int := 0;
   Window_Class_CbWndExtra : constant Win32.Int := 0;
   Window_Class_Icon : constant Win32.Windef.Hicon :=
     Win32.Winuser.Loadicon
     (Hinstance => System.Null_Address,
      Lpiconname => Win32.Lpcstr
      (Win32.Winuser.Idi_Application));
   Window_Class_Cursor : constant Win32.Windef.Hcursor :=
      Win32.Winuser.Loadcursor
     (Hinstance => System.Null_Address,
      Lpcursorname => Win32.Lpcstr
      (Win32.Winuser.Idc_Arrow));

   Window_Class_Background : constant Win32.Windef.Hbrush := 
     Win32.Wingdi.Getstockobject
     (Fnobject => Win32.Wingdi.White_Brush);
   Window_Class_Menu_Name : constant Win32.Lpcstr := null;

   -- for createwindow call
   Window_Style : constant Win32.Dword := 
     Win32.Winuser.Ws_Overlappedwindow;
   Window_Vertical_Start : constant Win32.Int := 
     Win32.Winuser.Cw_Usedefault;
   Window_Horizontal_Start : constant Win32.Int := 
     Win32.Winuser.Cw_Usedefault;
   Window_Width : constant Win32.Int := 
     Win32.Winuser.Cw_Usedefault;
   Window_Height : constant Win32.Int := 
     Win32.Winuser.Cw_Usedefault;
   Window_Parent : constant Win32.Windef.Hwnd := 
     System.Null_Address;
   window_menu   : constant win32.Windef.Hmenu := 
     System.Null_Address;
   Window_Parameters : constant Win32.Lpvoid := 
     System.Null_Address;
   Message_Filter_Minimum : constant Win32.Uint := 0;
   Message_Filter_Maximum : constant Win32.Uint := 0;

   -- define dummy variables to hold results of function calls
   Iresult : Win32.Int;
   Bresult : Win32.Bool;
--   Uresult : Win32.Uint;
   Lresult : Win32.Long;
   Aresult : Win32.Windef.Atom;


 end Windows.Data;
