-- Filename: sinewave.ads
--
-- This is the conversion of Petzold's Win 95
-- Chapter 4 program sinewave.  This file contains
-- the data structures needed for this program.
-- 
with Ada.Numerics.Generic_Elementary_Functions;

with Win32;
with Win32.Windef;

package Sinewave is
   use type Win32.Char_Array;

   Client_Width  : Win32.Int;
   Client_Height : Win32.Int;
   package math is new Ada.Numerics.Generic_Elementary_Functions(Win32.float);

   TWO_PI  : constant Win32.float := Win32.float (2.0 * Ada.Numerics.Pi); -- 3.14159);
   NUM_PTS : constant Win32.int := 1000;

   type Points_Array is array (Win32.Int range <>) of aliased Win32.Windef.Point;
   Points : Points_Array(1 .. num_pts);

end Sinewave;
