with Win32.Windef;
with Win32.Wingdi;
with Win32.Utils;
with Win32.Winuser;
with Windows.Data;
package body Windows.Child_Routines is
  use type Win32.Bool;
  use type Win32.Int;
  use type Win32.Word;

   Paint_Record             : aliased Win32.Winuser.Paintstruct;

   Device_Context_Handle    : aliased Win32.Windef.Hdc;

   Rectangle                : aliased Win32.Windef.Rect;

   False                    : constant Win32.Bool := 0;

   Integer_Result  : Win32.Int;

   Bool_Result     : Win32.Bool;

   Long_Result     : Win32.Long;

   Word_Result     : Win32.Word;

   function Child_Window
     (Window_Handle : Win32.Windef.Hwnd;
      Message       : Win32.Uint;
      Wparam        : Win32.Wparam;
      Lparam        : Win32.Lparam) return Win32.Lresult is
   begin

      case Message is

	 when Win32.Winuser.Wm_Create =>

           Word_Result :=
             Win32.Winuser.Setwindowword
               (Hwnd     => 
                 Window_Handle,
                Nindex   =>
                 0,
                Wnewword =>
                 0);

           return (0);

	 when Win32.Winuser.Wm_Lbuttondown =>

           Word_Result :=
             Win32.Winuser.Getwindowword
                (Hwnd   =>
                  Window_Handle,
                 Nindex =>
                  0);

           if Word_Result mod 2 = 0 then

             Word_Result :=
               Word_Result + 1;

           else

             Word_Result :=
               Word_Result - 1;
          
           end if;

           Word_Result :=
             Win32.Winuser.Setwindowword
               (Hwnd     =>
                 Window_Handle,
                Nindex   =>
                 0,
                Wnewword =>
                 Word_Result);

            Bool_Result :=
              Win32.Winuser.Invalidaterect
                (Hwnd   => 
                  Window_Handle,
                 Lprect => 
                  null,
                 Berase => 
                  False);

           return (0);

	 when Win32.Winuser.Wm_Paint =>

	   Device_Context_Handle :=
             Win32.Winuser.Beginpaint
	       (Hwnd    =>                                                       
                 Window_Handle,
	        Lppaint =>
                 Paint_Record'Access);

          Bool_Result :=
            Win32.Winuser.Getclientrect
              (Hwnd   =>
                Window_Handle,
               Lprect =>
                Rectangle'Access);
           
           Bool_Result :=
             Win32.Wingdi.Rectangle
               (Hdc         => 
                 Device_Context_Handle,
                Nleftrect   =>
                 0,
                Ntoprect   =>
                 0,
                Nrightrect  =>
                 Win32.Int
                   (Rectangle.Right),
                Nbottomrect =>
                 Win32.Int
                   (Rectangle.bottom));

           if Win32.Winuser.Getwindowword
                (Hwnd   => 
                  Window_Handle,
                 Nindex => 
                  0) /= 0 then

              Bool_result :=
                Win32.Wingdi.Movetoex
                  (Hdc     =>
                    Device_Context_Handle,
                   X       =>
                     0,
                   Y       => 
                     0,
                   Lppoint => 
                    null);

              Bool_Result :=
                Win32.Wingdi.Lineto
                  (Hdc  =>
                    Device_Context_Handle,
                   Xend =>
                    Win32.Int
                      (Rectangle.Right),
                   Yend =>
                    Win32.Int
                      (Rectangle.Bottom));

              Bool_result :=
                Win32.Wingdi.Movetoex
                  (Hdc     =>
                    Device_Context_Handle,
                   X       =>
                    0,
                   Y       => 
                    Win32.Int
                      (Rectangle.Bottom),
                   Lppoint => 
                    null);

              Bool_Result :=
                Win32.Wingdi.Lineto
                  (Hdc  =>
                    Device_Context_Handle,
                   Xend =>
                    Win32.Int
                      (Rectangle.Right),
                   Yend =>
                     0);

           end if;

    	   Bool_Result :=
             Win32.Winuser.Endpaint
               (Hwnd    =>
                 Window_Handle,
                Lppaint =>
                 Paint_Record'Access);

           return (0);

	 when Win32.WinUser.Wm_Destroy =>

	    Win32.WinUser.Postquitmessage
	      (Nexitcode => 
                0);

	    return (0);

	 when others =>

	    return Win32.Winuser.Defwindowproc
	      (Hwnd   =>
                Window_Handle, 
	       Msg    => 
                Message, 
	       Wparam => 
                Wparam,
	       Lparam => 
                Lparam);

      end case;

      return (0);

   end Child_Window;

end Windows.Child_Routines;
