with Ada.Unchecked_Conversion;
with Interfaces.C.Strings;
with System;
with Win32.Windef;
with Win32.Wingdi;
with Win32.Winmain;
with Win32.Utils;
with Win32.Winuser;
with Windows.Data;
package body Windows.Routines is
  use type Interfaces.C.Unsigned;
  use type System.Address;
  use type Win32.Bool;
  use type Win32.Int;

   Rectangle                : aliased win32.Windef.Rect;

--   Begining_Point           : Win32.Windef.Point;
--
--   Ending_Point             : Win32.Windef.Point;
--
--   Box_Begining_Point       : Win32.Windef.Point;
--
--   Box_Ending_Point         : Win32.Windef.Point;

   True                     : constant Win32.Bool := 1;

   False                    : constant Win32.Bool := 0;

   Flip_Flop                : Win32.Bool := False;

--   Is_Valid_Box             : Win32.Bool := False;

   Message_Box_Text         : constant Interfaces.C.Strings.Chars_Ptr := 
     Interfaces.C.Strings.New_String
       (Str =>
         "Too many clocks or timers!");

  Brush_Handle             : Win32.Windef.Hbrush;

   Paint_Record             : aliased win32.Winuser.Paintstruct;

   Window_Class             : aliased Win32.Winuser.Wndclass;

   Message                  : aliased Win32.Winuser.Msg;

   Device_Context_Handle    : aliased Win32.Windef.Hdc;

   Id_Timer                 : constant Win32.Uint := 1;

   Integer_Result           : Win32.Int;

   Uint_Result              : Win32.Uint;

   Bool_Result              : Win32.Bool;

   Long_Result              : Win32.Long;

   Atom_Result              : Win32.Windef.Atom;

   Object_Result            : Win32.Windef.Hgdiobj;

   Cursor_Result            : Win32.Windef.Hcursor;

   Window_Handle_Result     : Win32.Windef.Hwnd;

   function Convert_Char_Ptr_To_Lpcstr is new
     Ada.Unchecked_Conversion
       (Source => Interfaces.C.Strings.Chars_Ptr,
        Target => Win32.Lpcstr);

   procedure Main_Windows_Message_Loop is
   begin
      while (Win32.Winuser.Getmessage 
	     (Lpmsg => 
               Message'Access,
	      Hwnd  => 
               null, 
	      Wmsgfiltermin => 
               Windows.Data.Message_Filter_Minimum,
	      Wmsgfiltermax => 
               Windows.Data.Message_Filter_Maximum) /= 0) loop
	 
      	 Bool_Result := 
           Win32.Winuser.Translatemessage
	     (Lpmsg => 
               Message'Access);
	 
   	 Long_Result := 
           Win32.Winuser.Dispatchmessage
	     (Lpmsg => 
               Message'Access);
	 
      end loop;

   end Main_Windows_Message_Loop;

   function Main_Windows
     (Window_Handle : Win32.Windef.Hwnd;
      Message       : Win32.Uint;
      Wparam        : Win32.Wparam;
      Lparam        : Win32.Lparam) return Win32.Lresult is
   begin

      case Message is

	 when Win32.Winuser.Wm_Timer =>

           Bool_Result :=
             Win32.Winuser.Messagebeep
               (Utype =>
                 0);
                
           if Flip_Flop = True then

             Flip_Flop :=
               False;

           else

             Flip_Flop :=
               True;

           end if;

           Bool_Result := 
             Win32.Winuser.InvalidateRect
               (Hwnd   => 
                 Window_Handle,
                Lprect => 
                 null,
                Berase  => 
                 True);

           return (0);

	 when Win32.Winuser.Wm_Paint =>

	   Device_Context_Handle :=
             Win32.Winuser.Beginpaint
	       (Hwnd    =>                                                       
                 Window_Handle,
	        Lppaint =>
                 Paint_Record'Access);

           Bool_Result :=
             Win32.Winuser.Getclientrect
               (Hwnd   =>
                 Window_Handle,
                Lprect =>
                 Rectangle'Access);
           
           if Flip_Flop = True then

             Brush_Handle :=
               Win32.Wingdi.Createsolidbrush
                 (Clrref =>
                   Win32.Wingdi.RGB
                     (Bred   =>
                       255,
                      Bgreen =>
                       0,
                      Bblue  =>
                       0)); 

           else

             Brush_Handle :=
               Win32.Wingdi.Createsolidbrush
                 (Clrref =>
                   Win32.Wingdi.RGB
                     (Bred   =>
                       0,
                      Bgreen =>
                       0,
                      Bblue  =>
                       255)); 

           end if;
  
           Integer_Result :=
             Win32.Winuser.Fillrect
               (Hdc  =>
                 Device_Context_Handle,
                Lprc =>
                 Rectangle'Access,
                Hbr    =>
                 Brush_Handle);
  
    	    Bool_Result :=
              Win32.Winuser.Endpaint
                (Hwnd    =>
                  Window_Handle,
                 Lppaint =>
                  Paint_Record'Access);

           Bool_Result :=
             Win32.Wingdi.Deleteobject
               (Hgdiobj => 
                 Brush_Handle);

	    return (0);

	 when Win32.WinUser.Wm_Destroy =>

	    Win32.WinUser.Postquitmessage
	      (Nexitcode => 
                0);

	    return (0);

	 when others =>

	    return Win32.Winuser.Defwindowproc
	      (Hwnd   =>
                Window_Handle, 
	       Msg    => 
                Message, 
	       Wparam => 
                Wparam,
	       Lparam => 
                Lparam);

      end case;

      return (0);

   end Main_Windows;

   function Main
     (Instance          : Win32.Windef.Hinstance;
      Previous_instance : Win32.Windef.Hinstance;
      Command_Line      : Win32.Pcstr;
      Show_Command      : Win32.Int ) return Win32.Uint is
   begin

      if Previous_Instance = System.Null_Address then

	 Window_Class :=      
	   (Style         => 
             Windows.Data.Window_Class_Style,
	    Lpfnwndproc   => 
             Windows.Routines.Main_Windows'Access, 
	    Cbclsextra    => 
             Windows.Data.Window_Class_Cbclsextra,
	    Cbwndextra    => 
             Windows.Data.Window_Class_Cbwndextra,
	    Hinstance     => 
             Instance,
	    Hicon         => 
             Windows.Data.Window_Class_Icon,
	    Hcursor       => 
             Windows.Data.Window_Class_Cursor,
	    Hbrbackground => 
             Windows.Data.Window_Class_Background,
	    Lpszmenuname  => 
             Windows.Data.Window_Class_Menu_Name,
	    Lpszclassname => 
             Convert_Char_Ptr_To_Lpcstr
               (S => 
                 Windows.Data.Class_Name));

	 Atom_Result :=
	   win32.winuser.Registerclass
	   (Lpwndclass => 
             Window_Class'Access);

      end if;

      Windows.Data.Window_Handle := 
        Win32.WinUser.Createwindow
	  (Lpclassname => 
             Convert_Char_Ptr_To_Lpcstr
               (S => 
                 Windows.Data.Class_Name),
            Lpwindowname => 
             Convert_Char_Ptr_To_Lpcstr
               (S => 
                 Windows.Data.Caption),
            Dwstyle      => 
             Windows.Data.Window_Style,
            X            => 
             Windows.Data.Window_Horizontal_Start, 
            Y            => 
             Windows.Data.Window_Vertical_Start,
            Nwidth       => 
             Windows.Data.Window_Width,
            Nheight      => 
             Windows.Data.Window_Height,
            Hwndparent   => 
             Windows.Data.Window_Parent,
            Hmenu        => 
             Windows.Data.Window_Menu,
            Hinstance    => 
             Instance,
            Lpparam      => 
             Windows.Data.Window_Parameters);

    Uint_Result :=
     0;

    while Uint_Result = 0 loop 

      Uint_Result :=
        Win32.Winuser.Settimer
          (Hwnd        =>
            Windows.Data.Window_Handle,
           Nidevent    =>
            Id_Timer,
           Uelapse     =>
            1_000,
           Lptimerfunc =>
            null);

      if Uint_Result = 0 then

        if Win32.Winuser.MessageBox
             (Hwnd      => 
               Windows.Data.Window_Handle,
              Lptext    => 
               Convert_Char_Ptr_To_Lpcstr
                 (S => 
                   Message_Box_Text),
              Lpcaption =>
               Convert_Char_Ptr_To_Lpcstr
                 (S => 
                   Windows.Data.Caption),
              Utype     =>
               Win32.Winuser.Mb_Iconexclamation or
               Win32.Winuser.Mb_RetryCancel) = Win32.Winuser.Idcancel then

            return(0);     

         end if;

       end if;

    end loop;

    Bool_Result := 
      Win32.Winuser.Showwindow
        (Hwnd     => 
          Windows.Data.Window_Handle, 
	 Ncmdshow =>
          Win32.Winmain.Get_Ncmdshow);

    Bool_Result := 
      Win32.Winuser.Updatewindow
        (Hwnd => 
          Windows.Data.Window_Handle);

    Windows.Routines.Main_Windows_Message_Loop;

    return Message.Wparam;

  end Main;

end Windows.Routines;
