With Ada.Unchecked_Conversion;
with Win32.Wingdi;
with Win32.Utils;
with Windows.Data;
package body Windows.Child_Routines is
  use type Win32.Uint;
  use type Win32.Wparam;
   Long_Result     : Win32.Long;

   function Convert_Hwnd_To_Word is new
     Ada.Unchecked_Conversion
       (Source => Win32.Windef.Hwnd,
        Target => Win32.Word);

   function List
     (Window_Handle : Win32.Windef.Hwnd;
      Message       : Win32.Uint;
      Wparam        : Win32.Wparam;
      Lparam        : Win32.Lparam) return Win32.Lresult is
   begin

     if
       Message = Win32.Winuser.Wm_Keydown or 
       Wparam = Win32.Winuser.Vk_Return then

         Long_Result :=
           Win32.Winuser.SendMessage
             (Hwnd   =>
               Win32.Winuser.Getparent
                 (Hwnd =>
                   Window_Handle),
              Msg    => 
               Win32.Winuser.Wm_Command,
              Wparam => 
               1,
              Lparam => 
               Win32.Lparam
                 (Win32.Utils.Makelong
                   (Low  =>
                     (Convert_Hwnd_To_Word
                         (Window_Handle)),
                    High =>
                     Win32.Winuser.Lbn_Dblclk)));
                
 
     end if;

     return 
       Win32.Winuser.Callwindowproc
         (Lpprevwndfunc =>
           Old_Function_List,
          Hwnd          =>
           Window_Handle,
          Msg           =>
           Message,
          Wparam        =>
           Wparam,
          Lparam        =>
           Lparam);
   end List;

end Windows.Child_Routines;

