
--  ----------------------------------------------------------------------  --
--
--  Author  : Pascal Obry
--  E-Mail  : pascal.obry@der.edfgdf.fr
--
--  ----------------------------------------------------------------------  --
--
--  $Id: databases-transactions.adb,v 1.1 1996/10/07 15:12:29 obry Exp $
--
--  ----------------------------------------------------------------------  --
--
--       Module Name : Databases-Transactions
--         File name : databases-transactions.adb
--
--       Created by  : Pascal Obry
--               on  : Wed Apr 17 11:49:09 1996
--
--  Last modified by : $Author: obry $
--                     $Date: 1996/10/07 15:12:29 $
--                     $Revision: 1.1 $
--
--         Locked by : $Locker:  $
--
--  ======================================================================  --
--

with Databases.Options;

package body Databases.Transactions is

   procedure Auto_Commit (DB       : in Database;
                          Position : in Switch) is
   begin
      if Position = On then
         Options.Set (DB,
                      ODBC_EXT.SQL_AUTOCOMMIT,
                      ODBC_EXT.SQL_AUTOCOMMIT_ON);
      else
         Options.Set (DB,
                      ODBC_EXT.SQL_AUTOCOMMIT,
                      ODBC_EXT.SQL_AUTOCOMMIT_OFF);
      end if;
   end Auto_Commit;

   -------------------------------------------------------------------------

   procedure Commit (DB : in Database) is
      RC : ODBC.RETCODE;
   begin
      RC := ODBC.SQLTransact (DB.DBC_Environment_Handle,
                              DB.DBC_Handle,
                              ODBC.SQL_COMMIT);
      Check_SQL_Error (DB, RC, Procedure_Name => "Commit");
   end Commit;

   -------------------------------------------------------------------------

   procedure Rollback (DB : in Database) is
      RC : ODBC.RETCODE;
   begin
      RC := ODBC.SQLTransact (DB.DBC_Environment_Handle,
                              DB.DBC_Handle,
                              ODBC.SQL_ROLLBACK);
      Check_SQL_Error (DB, RC, Procedure_Name => "Rollback");
   end Rollback;

end Databases.Transactions;
