
--
-- Author : Pascal Obry
--
-- This is a sample program to show some OpenGL features.
--
-- It compile fine under GNAT 3.04a. You must add the following
-- libraries : OPENGL32.LIB GLU32.LIB GLAUX.LIB
--

with Win32.Gl;
with Win32.Glu;
with Win32.Glaux;
with Interfaces.C;
with Interfaces.C.Strings;
with System;
with Unchecked_Conversion;

procedure OGLCube is

   use Win32.Gl;
   use Win32.Glu;
   use Win32.Glaux;
   use Interfaces;

   function Conv is new Unchecked_Conversion (System.Address, AUXRESHAPEPROC);
   function Conv is new Unchecked_Conversion (System.Address, AUXMAINPROC);

   Window_Name : aliased C.Char_Array := C.To_C ("Perspective 3-D Cube");
   Res : Glenum;

   --  callbacks must be defined with the Stdcall Convention
   procedure MyReshape (W, H : in Glsizei);
   pragma Convention (Stdcall, MyReshape);

   procedure Display;
   pragma Convention (Stdcall, Display);

   --  here start the definition of the gl scene.
   procedure MyInit is
   begin
      GlShadeModel (GL_FLAT);
   end MyInit;

   procedure MyReshape (W, H : in Glsizei) is
   begin
      GlMatrixMode (GL_PROJECTION);
      GlLoadIdentity;
      GlFrustum (-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
      GlMatrixMode (GL_MODELVIEW);
      GlViewPort (0, 0, W, H);
   end MyReshape;

   procedure Display is
   begin
      GlClear (GL_COLOR_BUFFER_BIT);
      GlColor3f (1.0, 1.0, 1.0);
      GlLoadIdentity;
      GlTranslatef (0.0, 0.0, -5.0);
      GlScalef (1.0, 2.0, 1.0);
      AuxWireCube (1.0);
      GlFlush;
   end Display;

begin
   AuxInitDisplayMode (AUX_SINGLE + AUX_RGB);
   AuxInitPosition (0, 0, 500, 500);
   Res := AuxInitWindow (Window_Name (Window_Name'First)'Unchecked_Access);
   MyInit;
   AuxReshapeFunc (Conv(MyReshape'Address));
   Auxmainloop (Conv(Display'Address));
end OGLCube;
