-- $Source: /home/harp/1/proto/monoBANK/winnt/aliaspkg.ads,v $ 
-- $Revision: 1.6 $ $Date: 96/09/04 07:56:52 $ $Author: mg $ 
-- $Id: pcx.adb 1.5 1995/02/08 18:30:27 mps Exp mps $
--
--   PROGRAM: pcx.adb 
--
--   PURPOSE: Provide display of PCX files
-- 
--   COMMENTS:
--   The LabTek PCX Application Example is a sample application
--   that you can use to get an idea of how to perform some of the simple
--   functionality that the Windows GDI API implements.
--   Note that no 'use' clauses were used to help get a better idea on where 
--   various type are located in the binding.  Readability improves greatly
--   once a 'use Win32;' is used.
--
--   NOTES:
--   There is currently no help file.
--   pcxops.adb uses Unix style opens and reads instead of the Win32 variants.
--

with Interfaces.C;
with Win32.Winuser;
with Win32.Windef;
with Win32; use Win32;

package AliasPkg is

    function CP(S: Win32.CHAR_Array) return Win32.LPCSTR; -- utility function


	FILE_DISPLAYED   : BOOLEAN;                   -- is PCX file displayed?
	HINST            : Win32.WinDef.HINSTANCE;    -- current instance
	IRESULT          : Win32.INT;                 -- temp to hold results 
	PCXFILENAME      : Win32.LPCSTR;              -- ptr to PCX file
	

	-- aliased for procedure pcx
	appname      : aliased constant Win32.CHAR_Array := "pcx" & Win32.NUL;
	szappname    : Win32.LPCSTR;

	-- aliased for function WndProc
	aboutbox     : aliased constant Win32.CHAR_Array := "ABOUTBOX" & Win32.NUL;
	RECT         : aliased Win32.WinDef.RECT;
	CURSOR_RECT  : aliased Win32.WinDef.RECT;
	TL_POINT     : aliased Win32.WinDef.POINT;
	BR_POINT     : aliased Win32.WinDef.POINT;
	HELP_STR     : aliased Win32.CHAR_Array(0..255);


	-- aliased for function InitApplication
	WC : aliased Win32.WinUser.WNDCLASS;

	-- aliased for function InitApplication
    pcxTitle: aliased constant Win32.CHAR_Array := "PCX Sample Application" & Win32.NUL;



	function WndProc(HWND    : Win32.WinDef.HWND;
	                 MESSAGE : Win32.UINT;
	                 WPARAM  : Win32.WPARAM;
	                 LPARAM  : Win32.LPARAM) return Win32.LRESULT;
	pragma Convention(Stdcall, WndProc);

	function About(hDlg    : Win32.WinDef.HWND;
	               MESSAGE : Win32.UINT;
	               WPARAM  : Win32.WPARAM;
	               LPARAM  : Win32.LPARAM) return Win32.BOOL;
	pragma Convention (Stdcall, About);

-------------------------------------------------------------------------------
--
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED WITHOUT CHARGE
-- "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING
-- BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
-- FITNESS FOR A PARTICULAR PURPOSE.  The user assumes the entire risk as to
-- the accuracy and the use of this file.  This file may be used, copied,
-- modified and distributed only by licensees of Microsoft Corporation's
-- WIN32 Software Development Kit in accordance with the terms of the 
-- licensee's End-User License Agreement for Microsoft Software for the
-- WIN32 Development Kit.
--
-- Copyright (c) Intermetrics, Inc. 1995
-- Portions (c) 1985-1994 Microsoft Corporation with permission.
-- Microsoft is a registered trademark and Windows and Windows NT are
-- trademarks of Microsoft Corporation.
--
-------------------------------------------------------------------------------

end AliasPkg;
