-- $Source: /home/harp/1/proto/monoBANK/winnt/zoomin_pkg.ads,v $ 
-- $Revision: 1.8 $ $Date: 96/09/04 08:22:00 $ $Author: mg $ 


with Interfaces.C;
with Win32;
with Win32.Windef;
with Win32.Winnt;
with Win32.Winuser;


package Zoomin_Pkg is

    use Win32;	-- to get "&" and Nul

    function CP(S : Win32.CHAR_Array) return Win32.LPCSTR;

    appname    : aliased constant Win32.CHAR_Array := "Ada 95 ZoomIn" & Nul;
    icon_str   : aliased constant Win32.CHAR_Array := "zoomin" & Nul;
    WC         : aliased Win32.Winuser.WNDCLASS;
    BUFFER     : aliased Win32.CHAR_Array(0..1023);
    FTRANSLATED: aliased Win32.BOOL;


    MENU_HELP_ABOUT          : constant := 100;
    MENU_EDIT_COPY           : constant := 200;
    MENU_EDIT_REFRESH        : constant := 201;
    MENU_OPTIONS_REFRESHRATE : constant := 300;
    DID_ABOUT                : constant := 1000;
    DID_REFRESHRATE          : constant := 1100;
    DID_REFRESHRATEENABLE    : constant := 1101;
    DID_REFRESHRATEINTERVAL  : constant := 1102;
    IDMENU_ZOOMIN            : constant := 2000;
    IDACCEL_ZOOMIN           : constant := 3000;
    IDTIMER_ZOOMIN           : constant := 4000;

    MIN_ZOOM      : constant := 1;
    MAX_ZOOM      : constant := 32;
    FASTDELTA     : constant := 8;
    MM10PERINCH   : constant := 254;     -- Tenths of a millimeter per inch.
    NPAL          : constant := 256;     -- Number of palette entries.

    SZAPPNAME     : Win32.LPCSTR;
    GHINST        : Win32.Windef.HINSTANCE;-- Instance handle.
    GHWNDAPP      : Win32.Windef.HWND;     -- Main window handle.
    GHACCELTABLE  : Win32.Windef.HACCEL;   -- Main accelerator table.
    GNZOOM        : Win32.LONG;            -- Zoom (magnification) factor.
    GHPALPHYSICAL : Win32.Windef.HPALETTE; -- Handle to the physical palette.
    GCXSCREENMAX  : Win32.LONG;            -- Width of the screen (less 1).
    GCYSCREENMAX  : Win32.LONG;            -- Height of the screen (less 1).
    GCXZOOMED     : Win32.LONG;            -- Client width in zoomed pixels.
    GCYZOOMED     : Win32.LONG;            -- Client height in zoomed pixels.
    GFREFENABLE   : Win32.BOOL;            -- TRUE if refresh is enabled.
    GNREFINTERVAL : Win32.UINT;            -- Refresh interval in 10ths of sec.
    GFTRACKING    : Win32.BOOL;            -- TRUE if tracking is in progress.
    GPTZOOM       : Win32.Windef.LPPOINT;  -- center of the zoomed area.
    MESSAGE       : Win32.WinUser.LPMSG;
    HINST         : Win32.Windef.HINSTANCE;
    NCMDSHOW      : Win32.INT;


    -- dummy return values for some of the WinAPI function calls
    bResult       : Win32.BOOL;
    handResult    : Win32.Winnt.HANDLE;
    hcurResult    : Win32.WinDef.HCURSOR;
    hgdiResult    : Win32.WinDef.HGDIOBJ;
    hResult       : Win32.WinDef.HPALETTE;
    longResult    : Win32.LONG;
    siResult      : Win32.INT;
    uResult       : Win32.UINT;


    function AboutDlgProc(HWND_P   : Win32.Windef.HWND;
                          MSG      : Win32.UINT;
                          WPARAM_P : Win32.WPARAM;
                          LPARAM_P : Win32.LPARAM) return Win32.BOOL;
    pragma Convention(Stdcall, AboutDlgProc);
    

    function RefreshRateDlgProc(HWND_P   : Win32.Windef.HWND;
                                MSG      : Win32.UINT;
                                WPARAM_P : Win32.WPARAM;
                                LPARAM_P : Win32.LPARAM) return Win32.BOOL;
    pragma Convention(Stdcall, RefreshRateDlgProc);


    function AppWndProc(HWND_P   : Win32.Windef.HWND;
                        MSG      : Win32.UINT;
                        WPARAM_P : Win32.WPARAM;
                        LPARAM_P : Win32.LPARAM) return Win32.LRESULT;
    pragma Convention(Stdcall, AppWndProc);

    icon       : constant LPCSTR := icon_str(icon_str'first)'access;
    szicon     : Win32.LPCSTR;


-------------------------------------------------------------------------------
--
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED WITHOUT CHARGE
-- "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING
-- BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
-- FITNESS FOR A PARTICULAR PURPOSE.  The user assumes the entire risk as to
-- the accuracy and the use of this file.  This file may be used, copied,
-- modified and distributed only by licensees of Microsoft Corporation's
-- WIN32 Software Development Kit in accordance with the terms of the 
-- licensee's End-User License Agreement for Microsoft Software for the
-- WIN32 Development Kit.
--
-- Copyright (c) Intermetrics, Inc. 1995
-- Portions (c) 1985-1994 Microsoft Corporation with permission.
-- Microsoft is a registered trademark and Windows and Windows NT are
-- trademarks of Microsoft Corporation.
--
-------------------------------------------------------------------------------

end Zoomin_Pkg;

